package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ReservePolicyHand;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 储备项目政策处理信息 mapper
 * @author: 王强
 * @create: 2022-07-27 08:43
 **/
@MyBatisMapper
public interface PolicyHandingMapper extends BaseMapper<ReservePolicyHand> {

    /**
     * 根据项目储备id查询项目信息
     * @param reserveManagement
     * @return
     */
    ReservePolicyHand queryByProjectReserveId(ReservePolicyHand reserveManagement);


    /**
     * 批量添加项目储备信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<ReservePolicyHand> list);

    /**
     * 导出数据查询
     * @param reserveManagement
     * @return
     */
    List<ReservePolicyHand> exportFindList(ReservePolicyHand reserveManagement);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);

    /**
     * 根据executeId查出历史节点信息
     * @param executeId
     * @return
     */
    List<History> getHistoryByExecuteId(String executeId);

    /**
     * 根据executeId查出当前节点的名称
     * @param executeId
     * @return
     */
    String getByExecuteId(String executeId);
}
