package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils;

import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.*;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;
import java.util.List;

public class ReserveProcessProjectExportUtil {

    private  XSSFCellStyle style = null;

    public static ReserveProcessProjectExportUtil getOne(){

        return new ReserveProcessProjectExportUtil();
    }

    /**
     * 传入excel模板名称 获取workbook对象
     * @param fileName excel模板名称
     * @return
     */
    public  XSSFWorkbook getWorkbook(String fileName){
        InputStream inputStream = null;
        XSSFWorkbook workbook = null;
        try {
            File file = new File(this.getClass().getResource("/").getPath() + "/freemarker/excelmodel/"+fileName+".xlsx");
            inputStream = new FileInputStream(file);// 将excel文件转为输入流
            workbook = new XSSFWorkbook(inputStream);// 创建个workbook，
        } catch (Exception e) {
            e.printStackTrace();
        }
        return workbook;
    }

    /**
     * 导出储备项目带电作业基本信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportElectricityWork(HttpServletResponse response, XSSFWorkbook workbook, List<ReserveElectricityWork> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //建设必要性及内容
                Cell cell13 = crateCell(workbook,row,13); //变电站名称
                Cell cell14 = crateCell(workbook,row,14); //线路名称
                Cell cell15 = crateCell(workbook,row,15); //网架项目划分
                Cell cell16 = crateCell(workbook,row,16); //需求类型
                Cell cell17 = crateCell(workbook,row,17); //费用估算
                Cell cell18 = crateCell(workbook,row,18); //备注
                Cell cell19 = crateCell(workbook,row,19); //储备进度
                Cell cell20 = crateCell(workbook,row,20); //是否纳入实施计划
                Cell cell21 = crateCell(workbook,row,21); //初定实施批次
                Cell cell22 = crateCell(workbook,row,22); //项目类型
                Cell cell23 = crateCell(workbook,row,23); //是否含带电作业
                Cell cell24 = crateCell(workbook,row,24); //用户分界开关数量
                Cell cell25 = crateCell(workbook,row,25); //带电作业类型编号/次数
                Cell cell26 = crateCell(workbook,row,26); //不停电作业方案
                Cell cell27 = crateCell(workbook,row,27); //节约停电时户数
                Cell cell28 = crateCell(workbook,row,28); //无法不停电作业原因
                Cell cell29 = crateCell(workbook,row,29); //停电作业方案
                Cell cell30 = crateCell(workbook,row,30); //方案编制人
                Cell cell31 = crateCell(workbook,row,31); //现场查勘人


                ReserveElectricityWork reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell13.setCellValue(reserveManagement.getSubstationName());
                cell14.setCellValue(reserveManagement.getCircuitName());
                cell15.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell16.setCellValue(reserveManagement.getRequirementType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell17.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell18.setCellValue(reserveManagement.getBasicRemarks());
                cell19.setCellValue(reserveManagement.getReserveProgress());
                cell20.setCellValue(reserveManagement.getImplementPlan());
                cell21.setCellValue(reserveManagement.getImplementBatch());
                cell22.setCellValue(reserveManagement.getProjectType());
                cell23.setCellValue(reserveManagement.getHotLineWork());
                cell24.setCellValue(reserveManagement.getBoundarySwitchNum());
                cell25.setCellValue(reserveManagement.getHotLineWorkTypeNo());
                cell26.setCellValue(reserveManagement.getNoStopWorkPlan());
                cell27.setCellValue(reserveManagement.getPowerFailureNum());
                cell28.setCellValue(reserveManagement.getReasonsForNotWorkInterruption());
                cell29.setCellValue(reserveManagement.getPowerOutagePlan());
                cell30.setCellValue(reserveManagement.getPlanner());
                cell31.setCellValue(reserveManagement.getSiteSurveyor());



            }

            String str = URLEncoder.encode("储备项目带电作业信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储备项目基本信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportBasic(HttpServletResponse response, XSSFWorkbook workbook, List<ReserveProcessProject> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //建设必要性及内容
                Cell cell13 = crateCell(workbook,row,13); //变电站名称
                Cell cell14 = crateCell(workbook,row,14); //线路名称
                Cell cell15 = crateCell(workbook,row,15); //网架项目划分
                Cell cell16 = crateCell(workbook,row,16); //需求类型
                Cell cell17 = crateCell(workbook,row,17); //费用估算
                Cell cell18 = crateCell(workbook,row,18); //备注

                Cell cell19 = crateCell(workbook,row,19); //需求提报人
                Cell cell20 = crateCell(workbook,row,20); //业主储备专职
                Cell cell21 = crateCell(workbook,row,21); //业主配网专职
                Cell cell22 = crateCell(workbook,row,22); //业主项目经理
                Cell cell23 = crateCell(workbook,row,23); //业主物资专职
                Cell cell24 = crateCell(workbook,row,24); //技经人员
                Cell cell25 = crateCell(workbook,row,25); //运维人员

                Cell cell26 = crateCell(workbook,row,26); //设计人员
                Cell cell27 = crateCell(workbook,row,27); //概算编制人员
                Cell cell28 = crateCell(workbook,row,28); //不停电作业查勘人

                ReserveProcessProject reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell13.setCellValue(reserveManagement.getSubstationName());
                cell14.setCellValue(reserveManagement.getCircuitName());
                cell15.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell16.setCellValue(reserveManagement.getRequirementType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell17.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell18.setCellValue(reserveManagement.getBasicRemarks());

                cell19.setCellValue(reserveManagement.getRequester());
                cell20.setCellValue(reserveManagement.getOwnerReserveFullTime());
                cell21.setCellValue(reserveManagement.getOwnerDistributionNerworkFullTime());
                cell22.setCellValue(reserveManagement.getOwnerProjectManager());
                cell23.setCellValue(reserveManagement.getMaterialSoleDuty());
                cell24.setCellValue(reserveManagement.getTechnicalStaff());
                cell25.setCellValue(reserveManagement.getOperationAndMaintenancePersonnel());
                cell26.setCellValue(reserveManagement.getDesigner());
                cell27.setCellValue(reserveManagement.getBudgetPreparer());
                cell28.setCellValue(reserveManagement.getUninterruptedWorkSurveyPersonnel());

            }

            String str = URLEncoder.encode("储备项目基本信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储  作业查勘单
     * @param response
     * @param workbook
     * @param reserveManagement
     */
    public void exportSurveySheet(HttpServletResponse response, XSSFWorkbook workbook, ReserveElectricityWork reserveManagement){
        try {
            Sheet sheet = workbook.getSheetAt(0);

            String excelName = "";
            if (reserveManagement.getHotLineWork().equals("是")){
                Row nameRow = sheet.createRow(2);
                Row gcRow = sheet.createRow(4);
                Row btdyyRow = sheet.createRow(6);
                Row btdfaRow = sheet.createRow(10);
                Row ckrRow = sheet.createRow(18);

                Cell nameCell = crateCellNew(workbook,nameRow,0); //项目名称
                Cell gcCell = crateCellNew(workbook,gcRow,0); //工程内容
                Cell btdyyCell = crateCellNew(workbook,btdyyRow,0); //无法不停电作业原因
                Cell btdfaCell = crateCellNew(workbook,btdfaRow,0); //不停电作业方案
                Cell ckrCell = crateCellNew(workbook,ckrRow,0); //现场查勘人
                Cell bzrCell = crateCellNew(workbook,ckrRow,2); //方案编制人

                nameCell.setCellValue("项目名称");
                gcCell.setCellValue("工程内容");
                btdyyCell.setCellValue("无法不停电作业原因");
                btdfaCell.setCellValue("不停电作业方案");
                ckrCell.setCellValue("现场查勘人");
                bzrCell.setCellValue("方案编制人");

                Cell nameCell2 = crateCellNew(workbook,nameRow,1); //项目名称
                Cell gcCell2 = crateCellNew(workbook,gcRow,1); //工程内容
                Cell btdyyCell2 = crateCellNew(workbook,btdyyRow,1); //无法不停电作业原因
                Cell btdfaCell2 = crateCellNew(workbook,btdfaRow,1); //不停电作业方案
                Cell ckrCell2 = crateCellNew(workbook,ckrRow,1); //现场查勘人
                Cell bzrCell2 = crateCellNew(workbook,ckrRow,3); //方案编制人

                nameCell2.setCellValue(reserveManagement.getProjectName());
                gcCell2.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                btdyyCell2.setCellValue(reserveManagement.getReasonsForNotWorkInterruption());
                btdfaCell2.setCellValue(reserveManagement.getNoStopWorkPlan());
                ckrCell2.setCellValue(reserveManagement.getSiteSurveyor());
                bzrCell2.setCellValue(reserveManagement.getPlanner());
                excelName = "镇江公司设计阶段停电作业查勘单.xlsx";
            }else {
                Row nameRow = sheet.createRow(2);
                Row gcRow = sheet.createRow(4);
                Row faRow = sheet.createRow(6);
                Row hsRow = sheet.createRow(12);
                Row ckrRow = sheet.createRow(16);

                Cell nameCell = crateCellNew(workbook,nameRow,0); //项目名称
                Cell gcCell = crateCellNew(workbook,gcRow,0); //工程内容
                Cell faCell = crateCellNew(workbook,faRow,0); //不停电作业方案
                Cell hsCell = crateCellNew(workbook,hsRow,0); //预估节约停电时户数
                Cell ckrCell = crateCellNew(workbook,ckrRow,0); //现场查勘人
                Cell bzrCell = crateCellNew(workbook,ckrRow,2); //方案编制人
                nameCell.setCellValue("项目名称");
                gcCell.setCellValue("工程内容");
                faCell.setCellValue("不停电作业方案");
                hsCell.setCellValue("预估节约停电时户数");
                ckrCell.setCellValue("现场查勘人");
                bzrCell.setCellValue("方案编制人");


                Cell nameCell2 = crateCellNew(workbook,nameRow,1); //项目名称
                Cell gcCell2 = crateCellNew(workbook,gcRow,1); //工程内容
                Cell faCell2 = crateCellNew(workbook,faRow,1); //不停电作业方案
                Cell hsCell2 = crateCellNew(workbook,hsRow,1); //预估节约停电时户数
                Cell ckrCell2 = crateCellNew(workbook,ckrRow,1); //现场查勘人
                Cell bzrCell2 = crateCellNew(workbook,ckrRow,3); //方案编制人

                nameCell2.setCellValue(reserveManagement.getProjectName());
                gcCell2.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                faCell2.setCellValue(reserveManagement.getNoStopWorkPlan());
                hsCell2.setCellValue(reserveManagement.getPowerFailureNum());
                ckrCell2.setCellValue(reserveManagement.getSiteSurveyor());
                bzrCell2.setCellValue(reserveManagement.getPlanner());

                excelName = "镇江公司设计阶段不停电作业查勘单.xlsx";
            }


            String str = URLEncoder.encode(excelName, "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储备项目安全交底信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportSafety(HttpServletResponse response, XSSFWorkbook workbook, List<ReserveSafety> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //建设必要性及内容
                Cell cell13 = crateCell(workbook,row,13); //变电站名称
                Cell cell14 = crateCell(workbook,row,14); //线路名称
                Cell cell15 = crateCell(workbook,row,15); //网架项目划分
                Cell cell16 = crateCell(workbook,row,16); //需求类型
                Cell cell17 = crateCell(workbook,row,17); //费用估算
                Cell cell18 = crateCell(workbook,row,18); //备注
                Cell cell19 = crateCell(workbook,row,19); //储备进度
                Cell cell20 = crateCell(workbook,row,20); //是否临近（交叉）输电线路作业（含土建）
                Cell cell21 = crateCell(workbook,row,21); //是否临近（交叉）输电线路作业（含土建）-描述
                Cell cell22 = crateCell(workbook,row,22); //是否与输电线路同杆架设
                Cell cell23 = crateCell(workbook,row,23); //是否与输电线路同杆架设-描述
                Cell cell24 = crateCell(workbook,row,24); //是否与输电线路共沟
                Cell cell25 = crateCell(workbook,row,25); //是否与输电线路共沟-描述
                Cell cell26 = crateCell(workbook,row,26); //是否临近带电中压线路作业
                Cell cell27 = crateCell(workbook,row,27); //是否临近带电中压线路作业-描述
                Cell cell28 = crateCell(workbook,row,28); //是否有限空间作业
                Cell cell29 = crateCell(workbook,row,29); //是否有限空间作业-描述
                Cell cell30 = crateCell(workbook,row,30); //是否存在变电站出线电缆搭接-是
                Cell cell31 = crateCell(workbook,row,31); //是否存在变电站出线电缆搭接-是-描述
                Cell cell32 = crateCell(workbook,row,32); //是否存在跨越公路、铁路、航道作业
                Cell cell33 = crateCell(workbook,row,33); //是否存在跨越公路、铁路、航道作业-描述
                Cell cell34 = crateCell(workbook,row,34); //是否存在动火作业
                Cell cell35 = crateCell(workbook,row,35); //是否存在动火作业-描述
                Cell cell36 = crateCell(workbook,row,36); //是否需停电四条以上线路
                Cell cell37 = crateCell(workbook,row,37); //是否需停电四条以上线路-描述
                Cell cell38 = crateCell(workbook,row,38); //是否三条以上线路负荷改接
                Cell cell39 = crateCell(workbook,row,39); //是否三条以上线路负荷改接-描述
                Cell cell40 = crateCell(workbook,row,40); //是否多专业、多班组大型作业
                Cell cell41 = crateCell(workbook,row,41); //是否多专业、多班组大型作业-描述
                Cell cell42 = crateCell(workbook,row,42); //是否需编制三措
                Cell cell43 = crateCell(workbook,row,43); //是否需编制三措-描述
                Cell cell44 = crateCell(workbook,row,44); //作业风险等级预判


                ReserveSafety reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell13.setCellValue(reserveManagement.getSubstationName());
                cell14.setCellValue(reserveManagement.getCircuitName());
                cell15.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell16.setCellValue(reserveManagement.getRequirementType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell17.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell18.setCellValue(reserveManagement.getBasicRemarks());
                cell19.setCellValue(reserveManagement.getReserveProgress());
                cell20.setCellValue(reserveManagement.getTransmissionWork());
                cell21.setCellValue(reserveManagement.getWorkDescribe());
                cell22.setCellValue(reserveManagement.getTransmissionErection());
                cell23.setCellValue(reserveManagement.getErecteDescribe());
                cell24.setCellValue(reserveManagement.getTransmissionCommonTrench());
                cell25.setCellValue(reserveManagement.getTrenchDescribe());
                cell26.setCellValue(reserveManagement.getMediumVoltageWork());
                cell27.setCellValue(reserveManagement.getVoltageWorkDescribe());
                cell28.setCellValue(reserveManagement.getConfineSpaceWork());
                cell29.setCellValue(reserveManagement.getSpaceDescribe());
                cell30.setCellValue(reserveManagement.getSubStationCableBonding());
                cell31.setCellValue(reserveManagement.getCableDescribe());
                cell32.setCellValue(reserveManagement.getRoadRailwaysAndWaterwaysWork());
                cell33.setCellValue(reserveManagement.getWaterDescribe());
                cell34.setCellValue(reserveManagement.getHotWork());
                cell35.setCellValue(reserveManagement.getHotWorkDescribe());
                cell36.setCellValue(reserveManagement.getBlackoutLineFour());
                cell37.setCellValue(reserveManagement.getLineFourDescribe());
                cell38.setCellValue(reserveManagement.getLineLoadRedirectionThree());
                cell39.setCellValue(reserveManagement.getThreeRedirectDescribe());
                cell40.setCellValue(reserveManagement.getLargeScaleMultiTeamWork());
                cell41.setCellValue(reserveManagement.getTeamWorkDescribe());
                cell42.setCellValue(reserveManagement.getPrepareThreeMeasures());
                cell43.setCellValue(reserveManagement.getMeasureDescribe());
                cell44.setCellValue(reserveManagement.getJobRiskLevelPrediction());

            }

            String str = URLEncoder.encode("储备项目安全交底信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    /**
     * 导出储备项目预土建制化信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportPrecons(HttpServletResponse response, XSSFWorkbook workbook, List<ReservePreconstruction> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //建设必要性及内容
                Cell cell13 = crateCell(workbook,row,13); //变电站名称
                Cell cell14 = crateCell(workbook,row,14); //线路名称
                Cell cell15 = crateCell(workbook,row,15); //网架项目划分
                Cell cell16 = crateCell(workbook,row,16); //需求类型
                Cell cell17 = crateCell(workbook,row,17); //费用估算
                Cell cell18 = crateCell(workbook,row,18); //备注
                Cell cell19 = crateCell(workbook,row,19); //储备进度
                Cell cell20 = crateCell(workbook,row,20); //是否纳入实施计划
                Cell cell21 = crateCell(workbook,row,21); //初定实施批次
                Cell cell22 = crateCell(workbook,row,22); //交底预制化信息-是否含新建土建基础/包封
                Cell cell23 = crateCell(workbook,row,23); //交底预制化信息-是否预制化
                Cell cell24 = crateCell(workbook,row,24); //交底预制化信息-预制化描述
                Cell cell25 = crateCell(workbook,row,25); //设计预制化信息-是否含新建土建基础/包封
                Cell cell26 = crateCell(workbook,row,26); //设计预制化信息-是否预制化
                Cell cell27 = crateCell(workbook,row,27); //设计预制化信息-预制化描述


                ReservePreconstruction reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell13.setCellValue(reserveManagement.getSubstationName());
                cell14.setCellValue(reserveManagement.getCircuitName());
                cell15.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell16.setCellValue(reserveManagement.getRequirementType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell17.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell18.setCellValue(reserveManagement.getBasicRemarks());
                cell19.setCellValue(reserveManagement.getReserveProgress());
                cell20.setCellValue(reserveManagement.getImplementPlan());
                cell21.setCellValue(reserveManagement.getImplementBatch());
                cell22.setCellValue(reserveManagement.getConfessCivilFoundation());
                cell23.setCellValue(reserveManagement.getConfessPrefab());
                cell24.setCellValue(reserveManagement.getConfessPrefabDescription());
                cell25.setCellValue(reserveManagement.getDesignCivilFoundation());
                cell26.setCellValue(reserveManagement.getCastInPlaceList());
                cell27.setCellValue(reserveManagement.getDesignList());

            }

            String str = URLEncoder.encode("储备项目预土建制化信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储备项目政策处理信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportPolicy(HttpServletResponse response, XSSFWorkbook workbook, List<ReservePolicyHand> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //建设必要性及内容
                Cell cell13 = crateCell(workbook,row,13); //变电站名称
                Cell cell14 = crateCell(workbook,row,14); //线路名称
                Cell cell15 = crateCell(workbook,row,15); //网架项目划分
                Cell cell16 = crateCell(workbook,row,16); //需求类型
                Cell cell17 = crateCell(workbook,row,17); //费用估算
                Cell cell18 = crateCell(workbook,row,18); //备注
                Cell cell19 = crateCell(workbook,row,19); //储备进度
                Cell cell20 = crateCell(workbook,row,20); //是否纳入实施计划
                Cell cell21 = crateCell(workbook,row,21); //拟实施批次
                Cell cell22 = crateCell(workbook,row,22); //供电所辖区
                Cell cell23 = crateCell(workbook,row,23); //施工地点
                Cell cell24 = crateCell(workbook,row,24); //是否含土建工作量
                Cell cell25 = crateCell(workbook,row,25); //是否含立杆工作量
                Cell cell26 = crateCell(workbook,row,26); //项目经理
                Cell cell27 = crateCell(workbook,row,27); //拟定施工单位
                Cell cell28 = crateCell(workbook,row,28); //是否移交政处单位图纸
                Cell cell29 = crateCell(workbook,row,29); //是否存在政处
                Cell cell30 = crateCell(workbook,row,30); //政处描述
                Cell cell31 = crateCell(workbook,row,31); //政处难度
                Cell cell32 = crateCell(workbook,row,32); //政处对象数量
                Cell cell33 = crateCell(workbook,row,33); //政处对象描述（产权单位）
                Cell cell34 = crateCell(workbook,row,34); //政处类型
                Cell cell35 = crateCell(workbook,row,35); //启动政处时间
                Cell cell36 = crateCell(workbook,row,36); //是否需规划报批
                Cell cell37 = crateCell(workbook,row,37); //规划报批完成情况
                Cell cell38 = crateCell(workbook,row,38); //是否需办理安评航评手续
                Cell cell39 = crateCell(workbook,row,39); //安评完成情况
                Cell cell40 = crateCell(workbook,row,40); //政处对象金额
                Cell cell41 = crateCell(workbook,row,41); //是否完成付款
                Cell cell42 = crateCell(workbook,row,42); //政处进度
                Cell cell43 = crateCell(workbook,row,43); //是否允许土建进场
                Cell cell44 = crateCell(workbook,row,43); //是否允许电气进场
                Cell cell45 = crateCell(workbook,row,44); //是否允许开土建领料单
                Cell cell46 = crateCell(workbook,row,45); //是否允许开电气领料单
                Cell cell47 = crateCell(workbook,row,46); //政处进度-备注


                ReservePolicyHand reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell13.setCellValue(reserveManagement.getSubstationName());
                cell14.setCellValue(reserveManagement.getCircuitName());
                cell15.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell16.setCellValue(reserveManagement.getRequirementType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell17.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell18.setCellValue(reserveManagement.getBasicRemarks());
                cell19.setCellValue(reserveManagement.getReserveProgress());
                cell20.setCellValue(reserveManagement.getImplementPlan());
                cell21.setCellValue(reserveManagement.getIntendBatch());
                cell22.setCellValue(reserveManagement.getPowerSupplyArea());
                cell23.setCellValue(reserveManagement.getConstructionSpot());
                cell24.setCellValue(reserveManagement.getIncludeCivilWork());
                cell25.setCellValue(reserveManagement.getPoleWorkload());
                cell26.setCellValue(reserveManagement.getProjectManager());
                cell27.setCellValue(reserveManagement.getProposedConstructionUnit());
                cell28.setCellValue(reserveManagement.getOverToGovernment());
                cell29.setCellValue(reserveManagement.getGovernmentOffice());
                cell30.setCellValue(reserveManagement.getOfficeDescription());
                cell31.setCellValue(reserveManagement.getAdministrativeDifficulty());
                cell32.setCellValue(reserveManagement.getAdministrativeObjectNumber());
                cell33.setCellValue(reserveManagement.getPropertyUnitOfficeDescription());
                cell34.setCellValue(reserveManagement.getOfficeType());
                cell35.setCellValue(reserveManagement.getStartOfficeTime());
                cell36.setCellValue(reserveManagement.getPlanApprovalRequire());
                cell37.setCellValue(reserveManagement.getPlanApprovalCompletion());
                cell38.setCellValue(reserveManagement.getSafetyReview());
                cell39.setCellValue(reserveManagement.getSafetyReviewCompletion());
                cell40.setCellValue(reserveManagement.getOfficeAmount());
                cell41.setCellValue(reserveManagement.getPaymentCompleted());
                cell42.setCellValue(reserveManagement.getOfficeProgress());
                cell43.setCellValue(reserveManagement.getCivilEngineeringApproach());
                cell44.setCellValue(reserveManagement.getElectricApproach());
                cell45.setCellValue(reserveManagement.getCivilConstructionMaterialOpen());
                cell46.setCellValue(reserveManagement.getElectricalPickListOpen());
                cell47.setCellValue(reserveManagement.getAdministrativeOfficeRemark());


            }

            String str = URLEncoder.encode("储备项目政策处理信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储备项目交底信息汇总统计
     * @param response
     * @param workbook
     * @param list
     */
    public void exportSummary(HttpServletResponse response, XSSFWorkbook workbook, List<ReserveSummary> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //项目经理
                Cell cell7 = crateCell(workbook,row,7); //储备批次
                Cell cell8 = crateCell(workbook,row,8); //供电区域
                Cell cell9 = crateCell(workbook,row,9); //网格编号
                Cell cell10 = crateCell(workbook,row,10); //单元格编号
                Cell cell11 = crateCell(workbook,row,11); //项目储备编号
                Cell cell12 = crateCell(workbook,row,12); //项目名称
                Cell cell13 = crateCell(workbook,row,13); //建设必要性及内容
                Cell cell14 = crateCell(workbook,row,14); //变电站名称
                Cell cell15 = crateCell(workbook,row,15); //线路名称
                Cell cell16 = crateCell(workbook,row,16); //网架项目划分
                Cell cell17 = crateCell(workbook,row,17); //需求类型
                Cell cell18 = crateCell(workbook,row,18); //项目类型
                Cell cell19 = crateCell(workbook,row,19); //费用估算
                Cell cell20 = crateCell(workbook,row,20); //预算编制状态
                Cell cell21 = crateCell(workbook,row,21); //预算含税
                Cell cell22 = crateCell(workbook,row,22); //预算不含税
                Cell cell23 = crateCell(workbook,row,23); //备注
                Cell cell24 = crateCell(workbook,row,24); //储备进度
                Cell cell25 = crateCell(workbook,row,25); //是否纳入储备
                Cell cell26 = crateCell(workbook,row,26); //取消原因说明
                Cell cell27 = crateCell(workbook,row,27); //项目综合可实施性
                Cell cell28 = crateCell(workbook,row,28); //政处难度
                Cell cell29 = crateCell(workbook,row,29); //政处进度
                Cell cell30 = crateCell(workbook,row,30); //停电难度
                Cell cell31 = crateCell(workbook,row,31); //停电描述
                Cell cell32 = crateCell(workbook,row,32); //其他问题难度
                Cell cell33 = crateCell(workbook,row,33); //其他问题描述
                Cell cell34 = crateCell(workbook,row,34); //是否需重跑方案
                Cell cell35 = crateCell(workbook,row,35); //方案变更说明
                Cell cell36 = crateCell(workbook,row,36); //储备项目交底信息-备注
                Cell cell37 = crateCell(workbook,row,37); //需求单位优先级
                Cell cell38 = crateCell(workbook,row,38); //立项初安排
                Cell cell39 = crateCell(workbook,row,39); //初定实施批次
                Cell cell40 = crateCell(workbook,row,40); //初定实施单位
                Cell cell41 = crateCell(workbook,row,41); //储备项目推进计划（项目管理中心）
                Cell cell42 = crateCell(workbook,row,42); //项目管理单位完成进度
                Cell cell43 = crateCell(workbook,row,43); //储备项目推进计划（需求单位）
                Cell cell44 = crateCell(workbook,row,44); //需求单位完成进度
                Cell cell45 = crateCell(workbook,row,45); //政处计划（政处单位）
                Cell cell46 = crateCell(workbook,row,46); //政处进度
                Cell cell47 = crateCell(workbook,row,47); //是否出路径图
                Cell cell48 = crateCell(workbook,row,48); //储备项目推进计划-备注
                Cell cell49 = crateCell(workbook,row,49); //立项安排
                Cell cell50 = crateCell(workbook,row,50); //实施批次
                Cell cell51 = crateCell(workbook,row,51); //施工单位
                Cell cell52 = crateCell(workbook,row,52); //是否出正式图
                Cell cell53 = crateCell(workbook,row,53); //备注

                ReserveSummary reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getProjectManager());
                cell7.setCellValue(reserveManagement.getReserveBatches());
                cell8.setCellValue(reserveManagement.getBlockSupply());
                cell9.setCellValue(reserveManagement.getGridNumber());
                cell10.setCellValue(reserveManagement.getCellNumber());
                cell11.setCellValue(reserveManagement.getProjectReserveId());
                cell12.setCellValue(reserveManagement.getProjectName());
                cell13.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell14.setCellValue(reserveManagement.getSubstationName());
                cell15.setCellValue(reserveManagement.getCircuitName());
                cell16.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell17.setCellValue(reserveManagement.getRequirementType());
                cell18.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell19.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell20.setCellValue(reserveManagement.getBudgetPreparationStatus());
                cell21.setCellValue(reserveManagement.getBudgetIncludesTax());
                cell22.setCellValue(reserveManagement.getBudgetNotIncludesTax());
                cell23.setCellValue(reserveManagement.getBasicRemarks());
                cell24.setCellValue(reserveManagement.getReserveProgress());
                cell25.setCellValue(reserveManagement.getIncludeReserve());

                cell26.setCellValue(reserveManagement.getReasonForCancel());
                cell27.setCellValue(reserveManagement.getComprehensiveProject());
                cell28.setCellValue(reserveManagement.getOfficeDifficulty());
                cell29.setCellValue(reserveManagement.getOfficeProgress());
                cell30.setCellValue(reserveManagement.getPowerFailureDifficulty());
                cell31.setCellValue(reserveManagement.getPowerFailureDescribe());
                cell32.setCellValue(reserveManagement.getOtherProblemDifficulty());
                cell33.setCellValue(reserveManagement.getOtherProblemDescribe());
                cell34.setCellValue(reserveManagement.getRunPlanRequire());
                cell35.setCellValue(reserveManagement.getProgramChangeDescription());
                cell36.setCellValue(reserveManagement.getDiscloseRemarks());
                cell37.setCellValue(reserveManagement.getDemandUnitPriority());
                cell38.setCellValue(reserveManagement.getPreliminaryArrangement());
                cell39.setCellValue(reserveManagement.getInitialImplementBatch());
                cell40.setCellValue(reserveManagement.getInitialImplementUnit());
                cell41.setCellValue(reserveManagement.getProjectManagementCenter());
                cell42.setCellValue(reserveManagement.getCompleteProgressUnit());
                cell43.setCellValue(reserveManagement.getProjectReservePlan());
                cell44.setCellValue(reserveManagement.getDemandUnitProgress());
                cell45.setCellValue(reserveManagement.getDepartmentPlan());
                cell46.setCellValue(reserveManagement.getAdministrativeProgress());
                cell47.setCellValue(reserveManagement.getDrawMapPath());
                cell48.setCellValue(reserveManagement.getPlanRemarks());
                cell49.setCellValue(reserveManagement.getArrangementProject());
                cell50.setCellValue(reserveManagement.getImplementationBatch());
                cell51.setCellValue(reserveManagement.getConstructionUnit());
                cell52.setCellValue(reserveManagement.getDrawOfficeDrawn());
                cell53.setCellValue(reserveManagement.getProjectInitiateRemarks());
            }

            String str = URLEncoder.encode("储备项目交底信息汇总统计.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出省公司评审信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportCompany(HttpServletResponse response, XSSFWorkbook workbook, List<CompanyReview> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //建设必要性及内容
                Cell cell13 = crateCell(workbook,row,13); //变电站名称
                Cell cell14 = crateCell(workbook,row,14); //线路名称
                Cell cell15 = crateCell(workbook,row,15); //网架项目划分
                Cell cell16 = crateCell(workbook,row,16); //需求类型
                Cell cell17 = crateCell(workbook,row,17); //费用估算
                Cell cell18 = crateCell(workbook,row,18); //备注
                Cell cell19 = crateCell(workbook,row,19); //是否参加省公司评审
                Cell cell20 = crateCell(workbook,row,20); //省公司评审批次/日期
                Cell cell21 = crateCell(workbook,row,21); //是否通过省公司评审
                Cell cell22 = crateCell(workbook,row,22); //评审意见
                Cell cell23 = crateCell(workbook,row,23); //是否需设计变更
                Cell cell24 = crateCell(workbook,row,24); //备注


                CompanyReview companyReview = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(companyReview.getProjectYear());
                cell2.setCellValue(companyReview.getProjectNature());
                cell3.setCellValue(companyReview.getDemandUnit());
                cell4.setCellValue(companyReview.getDistrict());
                cell5.setCellValue(companyReview.getProjectGroup());
                cell6.setCellValue(companyReview.getReserveBatches());
                cell7.setCellValue(companyReview.getBlockSupply());
                cell8.setCellValue(companyReview.getGridNumber());
                cell9.setCellValue(companyReview.getCellNumber());
                cell10.setCellValue(companyReview.getProjectReserveId());
                cell11.setCellValue(companyReview.getProjectName());
                cell12.setCellValue(companyReview.getConstructionNecessityAndContent());
                cell13.setCellValue(companyReview.getSubstationName());
                cell14.setCellValue(companyReview.getCircuitName());
                cell15.setCellValue(companyReview.getNetRackProjectDivide());
                cell16.setCellValue(companyReview.getRequirementType());

                String costEstimateStr= companyReview.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell17.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell18.setCellValue(companyReview.getBasicRemarks());
                cell19.setCellValue(companyReview.getJoinProvincialCompanyReview());
                cell20.setCellValue(companyReview.getBatchOfProvincialCompany());
                cell21.setCellValue(companyReview.getPassProvincialCompanyReview());
                cell22.setCellValue(companyReview.getReviewComments());
                cell23.setCellValue(companyReview.getDesignChangeRequired());
                cell24.setCellValue(companyReview.getCompanyRemarks());
            }

            String str = URLEncoder.encode("省公司评审.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 创建Cell对象 同时设置style
     * @param workbook
     * @param row
     * @param num
     * @return
     */
    Cell crateCell(XSSFWorkbook workbook,Row row, int num){
        Cell cell = row.createCell(num);
        if(style == null){
            style =workbook.createCellStyle();
            style.setWrapText(true);
            style.setVerticalAlignment(XSSFCellStyle.VERTICAL_CENTER);
        }
        cell.setCellStyle(style);
        return cell;
    }

    /**
     * 创建Cell对象 同时设置style
     * @param workbook
     * @param row
     * @param num
     * @return
     */
    Cell crateCellNew(XSSFWorkbook workbook,Row row, int num){
        Cell cell = row.createCell(num);
        //设置样式
        XSSFCellStyle style = workbook.createCellStyle();
        style.setAlignment(XSSFCellStyle.ALIGN_CENTER); //水平居中
        style.setVerticalAlignment(XSSFCellStyle.VERTICAL_CENTER);  //垂直居中
        style.setWrapText(true);//自动换行

        cell.setCellStyle(style);
        return cell;
    }
}
