package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils;

import org.springframework.stereotype.Component;
import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPool;
import redis.clients.jedis.JedisPoolConfig;

/**
 * redis工具类
 * @author: 王强
 * @create: 2022-08-26 10:05
 **/
@Component
public class ReserveRedisUtils {

    private static String ip = "localhost";
    private static int port = 6379;
    private static int timeout = 10000;
    private static JedisPool pool = null;

    static {
        JedisPoolConfig config = new JedisPoolConfig();
        //设置最大空闲数
        config.setMaxIdle(200);
        //设置最大连接数
        config.setMaxTotal(1024);
        //等待池连接最长时间
        config.setMaxWaitMillis(10000);
        //是否提前validate操作
        config.setTestOnBorrow(true);


        pool = new JedisPool(config,ip,port,timeout);
    }

    //得到redis连接
    public static Jedis getJedis(){
        if (pool == null){
            return null;
        }
        return pool.getResource();
    }

    //关闭redis连接
    public static void close(Jedis redis){
        if (redis != null){
            redis.close();
        }
    }

}
