package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.web;

import com.jeeplus.common.config.Global;
import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.DateUtils;
import com.jeeplus.common.utils.PropertiesLoader;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.common.utils.excel.ExportExcel;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.core.web.Servlets;
import com.jeeplus.modules.act.entity.Act;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.Demolite;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.DocumentInfo;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ReserveSummaryProcess;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.*;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils.DataList;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils.ReserveProcessProjectProUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.service.EnginnerQueryService;
import com.jeeplus.modules.sg.managementcenter.materialinfo.entity.MaterialInfo;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import com.jeeplus.modules.sg.managementcenter.reserveManagement.entity.ReserveProcess;
import com.jeeplus.modules.sg.picking.activiti.entity.ShowList;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.mock.web.MockMultipartFile;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author: 王强
 * @create: 2022-08-03 10:33
 **/
@Controller
@RequestMapping(value = "${adminPath}/cg/reservemanagementcenter/process")
public class ProcessController extends BaseController {

    /**
     * 判断服务器系统类型，1是windows系统，2是linux系统
     */
    public static final String SYS_TYPE = System.getProperty("os.name").toLowerCase().startsWith("win") ? "1" : "2";

    /**
     * 属性文件加载对象
     */
    private static PropertiesLoader loader = new PropertiesLoader("/properties/jeeplus.properties");

    @Autowired
    private ReserveSummaryProcessService reserveProcessService;

    @Autowired
    private ReserveElectricityWorkService workService;

    @Autowired
    private ReservePreconstructService preconstructService;

    @Autowired
    private EnginnerQueryService queryService;

    @Autowired
    private DemoliteService demoliteService;

    @Autowired
    private DocumentInfoService infoService;

    @ModelAttribute
    public ReserveSummaryProcess get(@RequestParam(required = false) String id) {
        ReserveSummaryProcess entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = reserveProcessService.get(id);
        }
        if (entity == null) {
            entity = new ReserveSummaryProcess();
        }
        return entity;
    }

    /**
     * 设计单位审核
     */
    @RequestMapping(value = "designUnit")
    public String designUnit(ReserveSummaryProcess reserveProcess, Model model) {

        //查看历史数据
        DocumentInfo infoByProId = infoService.getInfoByProId(reserveProcess.getProjectReserveId());
        int count = reserveProcessService.getCountByName(reserveProcess.getProjectName());
        //如果不为空，  将数据赋值给reserveProcess
        if (infoByProId != null){
            //将文件地址赋值给reserveProcess
            reserveProcess.setBudgetStatement(infoByProId.getBudgetStatement());
            reserveProcess.setProjectProposal(infoByProId.getProjectProposal());
            reserveProcess.setDrawings(infoByProId.getDrawings());
            reserveProcess.setDrawingSpecification(infoByProId.getDrawingSpecification());
            reserveProcess.setDemolition(infoByProId.getDemolition());
            reserveProcess.setApprovalForm(infoByProId.getApprovalForm());

        }
        if (count>0){
            model.addAttribute("material", "测试");
            model.addAttribute("drjgc", "测试");
        }

        model.addAttribute("reserveProcess", reserveProcess);
        return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/designUnit";
    }

    /**
     * 设计单位审核-上传预算书
     */
    @RequestMapping(value = "designUnitAgain")
    public String designUnitAgain(ReserveSummaryProcess reserveProcess, Model model) {
        model.addAttribute("reserveProcess", reserveProcess);
        return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/designUnitAgain";
    }

    /**
     * 设计单位审核-上传预算书,查看驳回意见
     */
    @RequestMapping(value = "designUnitAgainTwo")
    public String designUnitAgainTwo(ReserveSummaryProcess reserveProcess, Model model) {
        model.addAttribute("reserveProcess", reserveProcess);
        return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/designUnitAgainTwo";
    }

    /**
     * 项目经理审图（储备专职/配网项目经理）
     */
    @RequestMapping(value = "drawingReview")
    public String drawingReview(ReserveSummaryProcess reserveProcess, Model model) {
        model.addAttribute("reserveProcess", reserveProcess);
        return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/drawingReview";
    }

    /**
     * 联合审图（储备专职/配网项目经理）
     */
    @RequestMapping(value = "drawingReviewTest")
    public String drawingReviewTest(ReserveSummaryProcess reserveProcess, Model model) {
        model.addAttribute("reserveProcess", reserveProcess);
        return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/test/drawingReviewTest";
    }

    /**
     * 技经人员审预算
     */
    @RequestMapping(value = "budgetReview")
    public String budgetReview(ReserveSummaryProcess reserveProcess, Model model) {
        model.addAttribute("reserveProcess", reserveProcess);
        return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/budgetReview";
    }

    /**
     * 年度物资上报明细 多文件导入验证
     */
    @ResponseBody
    @RequestMapping(value = "importCGValidations")
    public AjaxJson importCGValidations(@RequestParam("file") MultipartFile[] file) {
        AjaxJson j = new AjaxJson();

        try {
            for (int k = 0; k < file.length; k++) {
                reserveProcessService.saveData(file[k]);
            }
            j.setSuccess(true);
            j.setErrorCode("0");
            j.setMsg("导入成功");
        } catch (Exception e) {
            j.setSuccess(true);
            j.setMsg("导入失败！失败信息：" + e.getMessage());
        }
        return j;
    }

    /***
     * 设计单位审核  新
     * */
    @ResponseBody
    @RequestMapping(value = "actDesignUnitNew")
    public AjaxJson actDesignUnitNew(Act act, ReserveSummaryProcess reserveProcess,String material,String drjgc) throws Exception {
        AjaxJson j = new AjaxJson();

        if (material != null || drjgc != null){
            //将上传的文件进行持久化操作
            //保存文件地址
            DocumentInfo infoByProId = new DocumentInfo(reserveProcess.getProjectReserveId(),reserveProcess.getBudgetStatement(),reserveProcess.getProjectProposal(),
                    reserveProcess.getDrawings(),
                    reserveProcess.getDrawingSpecification(),reserveProcess.getDemolition(),
                    reserveProcess.getApprovalForm());
            infoService.save(infoByProId);

            //在将拆旧清册数据存入数据库前先查出库中有没有这个project ReserveId的相关数据
            String projectReserveId = reserveProcess.getProjectReserveId();
            demoliteService.deleteByProjectReserveId(projectReserveId);
            //获取拆旧清册数据
            //String index out of range: -1 这个异常一般是截取字符串时报的错误。
            File file = new File(reserveProcess.getDemolition());
            String path = file.getAbsolutePath();
//            int index = file.getAbsolutePath().indexOf("\\fileServer");
            int index = file.getAbsolutePath().indexOf("fileServer");
//            path = path.substring(index);

            String FILE_PREFIX = loader.getProperty("linux.file.store.prefix");

            if (SYS_TYPE.equals("1")) {
                path = path.substring(index-1);

            } else {
                //liunx file store prefix
                path = FILE_PREFIX + Servlets.getRequest().getContextPath() + path.substring(index-1);
                path = path.replaceAll("\\\\","/");
            }

            File demoFile = new File(path);

            InputStream inputStream = new FileInputStream(demoFile);
            MultipartFile multipartFile = new MockMultipartFile("file", demoFile.getName(), null, inputStream);
            ImportUtil importUtil = new ImportUtil(multipartFile, 0, 0);
            //获取导入表格所有数据
            List<Demolite> reserveManagementList = ReserveProcessProjectProUtil.getDemoliteUtil(importUtil, projectReserveId);
            //将数据存入数据库
            demoliteService.insertList(reserveManagementList);

            String flag = act.getFlag();
            try {
                String comment = URLDecoder.decode(act.getComment(), "UTF-8");
                act.setComment(comment);
                if ("yes".equals(flag)) {

                    //从redis中查看是否有在线开甲供材数据
                    List<?> list = DataList.getList(reserveProcess.getProjectReserveId());
                    List<MaterialInfo> infoList = new ArrayList<>();
                    ShowList showList = null;
                    MaterialInfo info = null;
                    if ("".equals(drjgc) & "".equals(material)) {
                        j.setMsg("该项目没有甲供材清册");
                        j.setSuccess(false);
                        return j;
                    }else if ("".equals(drjgc) & !"".equals(material)){
                        //将redis中的数据存入数据库   cg_material_data
                        for (int i=0;i<list.size();i++){
                            showList = (ShowList) list.get(i);
                            info = new MaterialInfo();
                            info.setProjectName(showList.getProjectName());
                            info.setMaterialCode(showList.getMaterialCode());
                            info.setMaterialName(showList.getMaterialDescription());
                            info.setExtendDescription(showList.getExtensionDescription());
                            info.setUnit(showList.getMdUnits());
                            info.setTotalCount(showList.getMdTotalAmount());
                            info.setWeightKg(showList.getMdSingleWeight());
                            info.setWeightTon(showList.getMdTotalWeight());
                            info.setSupplyType(showList.getMdTheParty());
                            info.setNote(showList.getMdText());
                            infoList.add(info);
                        }
                        //保存甲供材信息
                        reserveProcessService.saveList(infoList);
                        //修改项目设计单位上传文件部分
//                        reserveProcessService.updateDesign(reserveProcess);
                        reserveProcessService.actDesignUnit(act, reserveProcess);

                        //设置带电作业信息表 相关字段值
                        Double allNum = reserveProcessService.getAllNum("500138348");
                        workService.updateSwitchNum(allNum == null ? "" : allNum + "");

                        //获取新建土建包封数据总和
                        double bfSum = 0.0;
                        if (queryService.getTJBFData() != null){
                            bfSum = bfSum + queryService.getTJBFData();

                        }
                        //获取新建土建基础数据总和
                        double jcSum = 0.0;
                        if (queryService.getTJJCData() != null){
                            jcSum = jcSum + queryService.getTJJCData();

                        }
                        double divide = jcSum/bfSum;

//                        //获取所有的 物料编码，扩展描述，总量信息
//                        List<MaterialData> materialData = queryService.findAllCount();
//
//                        //现场浇筑清单
//                        Double decimal1 = 0.0;
//                        Double decimal2 = 0.0;
//                        Double decimal3 = 0.0;
//                        Double decimal4 = 0.0;
//                        Double decimal5 = 0.0;
//                        Double decimal6 = 0.0;
//
//                        //预制化清单
//                        Double decimal7 = 0.0;
//                        Double decimal8 = 0.0;
//                        Double decimal9 = 0.0;
//                        Double decimal10 = 0.0;
//                        Double decimal11 = 0.0;
//                        Double decimal12 = 0.0;
//                        Double decimal13 = 0.0;
//                        Double decimal14 = 0.0;
//                        Double decimal15 = 0.0;
//                        Double decimal16 = 0.0;
//                        Double decimal17 = 0.0;
//                        Double decimal18 = 0.0;
//                        Double decimal19 = 0.0;
//                        for (int i=0;i<materialData.size();i++){
//                            if (materialData.get(i).getMaterialCode().equals("乙供")){
//                                //现场浇筑清单
//                                if (materialData.get(i).getExtendDescription().equals("配农网用,整套杆,GNH31-13-B")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal1 = decimal1 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("GNH35-13；灌注桩")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal2 = decimal2 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("GNH39-13；灌注桩")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal3 = decimal3 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("GNH31-13；台阶式基础")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal4 = decimal4 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("GNH35-13；台阶式基础")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal5 = decimal5 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("GNH39-13；台阶式基础")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal6 = decimal6 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//
//                                //预制化清单
//                                if (materialData.get(i).getExtendDescription().equals("预制化排管，2×3（5+1），≤100kN")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal7 = decimal7 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("预制化排管，2×4（7+1），≤100kN")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal8 = decimal8 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("预制化排管，3×4（11+1），≤100kN")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal9 = decimal9 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("预制化排管，4×3（11+1），≤100kN")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal10 = decimal10 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("预制化排管，4×4（15+1），≤100kN")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal11 = decimal11 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("预制化排管，4×5（19+1），≤100kN")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal12 = decimal12 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("预制化直线井，3×2.0×1.9，人孔")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal13 = decimal13 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("预制化三通井，3×2.8×1.9，人孔")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal14 = decimal14 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("预制化八角井，4.0×4.0×1.9，人孔")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal15 = decimal15 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("两进两出环网箱基础预制，3.2×1.15×1.6")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal16 = decimal16 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("两进四出环网箱基础预制，4.0×1.15×1.6")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal17 = decimal17 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("紧凑型箱变基础预制，2.45×1.15×1.6")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal18 = decimal18 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//                                if (materialData.get(i).getExtendDescription().equals("标准型箱变基础预制，3.3×2.2×1.6")
//                                        & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                    decimal19 = decimal19 + Double.valueOf(materialData.get(i).getTotalCount());
//                                }
//
//                            }
//
//                        }
//
//                        //设置    现场浇筑清单数据
//                        String castInPlaceList = "";
//                        if (StringUtils.isNotEmpty(decimal1.toString()) & decimal1 != 0.0){
//                            castInPlaceList = decimal1.toString() + "基" + "配农网用,整套杆,GNH31-13-B";
//                        }
//                        if (StringUtils.isNotEmpty(decimal2.toString()) & decimal2 != 0.0){
//                            castInPlaceList = castInPlaceList + ";" + decimal2.toString() + "基" + "GNH35-13；灌注桩";
//                        }
//                        if (StringUtils.isNotEmpty(decimal3.toString()) & decimal3 != 0.0){
//                            castInPlaceList = castInPlaceList + ";" + decimal3.toString() + "基" + "GNH39-13；灌注桩";
//                        }
//                        if (StringUtils.isNotEmpty(decimal4.toString()) & decimal4 != 0.0){
//                            castInPlaceList = castInPlaceList + ";" + decimal4.toString() + "基" + "GNH31-13；台阶式基础";
//                        }
//                        if (StringUtils.isNotEmpty(decimal5.toString()) & decimal5 != 0.0){
//                            castInPlaceList = castInPlaceList + ";" + decimal5.toString() + "基" + "GNH35-13；台阶式基础";
//                        }
//                        if (StringUtils.isNotEmpty(decimal6.toString()) & decimal6 != 0.0){
//                            castInPlaceList = castInPlaceList + ";" + decimal6.toString() + "基" + "GNH39-13；台阶式基础";
//                        }
//
//                        String designList = "";
//                        if (StringUtils.isNotEmpty(decimal7.toString()) & decimal7 != 0.0){
//                            designList = decimal7.toString() + "米" + "预制化排管，2×3（5+1），≤100kN";
//                        }
//                        if (StringUtils.isNotEmpty(decimal8.toString()) & decimal8 != 0.0){
//                            designList = designList + ";" + decimal8.toString() + "米" + "预制化排管，2×4（7+1），≤100kN";
//                        }
//                        if (StringUtils.isNotEmpty(decimal9.toString()) & decimal9 != 0.0){
//                            designList = designList + ";" + decimal9.toString() + "米" + "预制化排管，3×4（11+1），≤100kN";
//                        }
//                        if (StringUtils.isNotEmpty(decimal10.toString()) & decimal10 != 0.0){
//                            designList = designList + ";" + decimal10.toString() + "米" + "预制化排管，4×3（11+1），≤100kN";
//                        }
//                        if (StringUtils.isNotEmpty(decimal11.toString()) & decimal11 != 0.0){
//                            designList = designList + ";" + decimal11.toString() + "米" + "预制化排管，4×4（15+1），≤100kN";
//                        }
//                        if (StringUtils.isNotEmpty(decimal12.toString()) & decimal12 != 0.0){
//                            designList = designList + ";" + decimal12.toString() + "米" + "预制化排管，4×5（19+1），≤100kN";
//                        }
//                        if (StringUtils.isNotEmpty(decimal13.toString()) & decimal13 != 0.0){
//                            designList = designList + ";" + decimal13.toString() + "座" + "预制化直线井，3×2.0×1.9，人孔";
//                        }
//                        if (StringUtils.isNotEmpty(decimal14.toString()) & decimal14 != 0.0){
//                            designList = designList + ";" + decimal14.toString() + "座" + "预制化三通井，3×2.8×1.9，人孔";
//                        }
//                        if (StringUtils.isNotEmpty(decimal15.toString()) & decimal15 != 0.0){
//                            designList = designList + ";" + decimal15.toString() + "座" + "预制化八角井，4.0×4.0×1.9，人孔";
//                        }
//                        if (StringUtils.isNotEmpty(decimal16.toString()) & decimal16 != 0.0){
//                            designList = designList + ";" + decimal16.toString() + "座" + "两进两出环网箱基础预制，3.2×1.15×1.6";
//                        }
//                        if (StringUtils.isNotEmpty(decimal17.toString()) & decimal17 != 0.0){
//                            designList = designList + ";" + decimal17.toString() + "座" + "两进四出环网箱基础预制，4.0×1.15×1.6";
//                        }
//                        if (StringUtils.isNotEmpty(decimal18.toString()) & decimal18 != 0.0){
//                            designList = designList + ";" + decimal18.toString() + "座" + "紧凑型箱变基础预制，2.45×1.15×1.6";
//                        }
//                        if (StringUtils.isNotEmpty(decimal19.toString()) & decimal19 != 0.0){
//                            designList = designList + ";" + decimal19.toString() + "座" + "标准型箱变基础预制，3.3×2.2×1.6";
//                        }
//
//                        if (divide >0 ){
//                            //修改  是否含新建土建基础/包封 为是
//                            preconstructService.updateMetion("是",castInPlaceList,designList);
//                        }else {
//                            preconstructService.updateMetion("否",castInPlaceList,designList);
//                        }

                    }else {
                        //修改项目设计单位上传文件部分
//                        reserveProcessService.updateDesign(reserveProcess);
                        reserveProcessService.actDesignUnit(act, reserveProcess);
                    }
                } else {
                    reserveProcessService.actDesignUnit(act, reserveProcess);
                }
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        }

        j.setMsg("审批成功");
        return j;
    }

    /***
     * 设计单位审核
     * */
    @ResponseBody
    @RequestMapping(value = "actDesignUnit")
    public AjaxJson actDesignUnit(Act act, ReserveSummaryProcess reserveProcess,String material,String drjgc) throws Exception {
        AjaxJson j = new AjaxJson();
        if (reserveProcess.getDemolition() != null) {
            //在将拆旧清册数据存入数据库前先查出库中有没有这个project ReserveId的相关数据
            String projectReserveId = reserveProcess.getProjectReserveId();
            demoliteService.deleteByProjectReserveId(projectReserveId);
            //获取拆旧清册数据
            //String index out of range: -1 这个异常一般是截取字符串时报的错误。
            File file = new File(reserveProcess.getDemolition());
            String path = file.getAbsolutePath();
//            int index = file.getAbsolutePath().indexOf("\\fileServer");
            int index = file.getAbsolutePath().indexOf("fileServer");
//            path = path.substring(index);

            String FILE_PREFIX = loader.getProperty("linux.file.store.prefix");

            if (SYS_TYPE.equals("1")) {
                path = path.substring(index-1);

            } else {
                //liunx file store prefix
                path = FILE_PREFIX + Servlets.getRequest().getContextPath() + path.substring(index-1);
                path = path.replaceAll("\\\\","/");
            }

            File demoFile = new File(path);

            InputStream inputStream = new FileInputStream(demoFile);
            MultipartFile multipartFile = new MockMultipartFile("file", demoFile.getName(), null, inputStream);
            ImportUtil importUtil = new ImportUtil(multipartFile, 0, 0);
            //获取导入表格所有数据
            List<Demolite> reserveManagementList = ReserveProcessProjectProUtil.getDemoliteUtil(importUtil, projectReserveId);
            //将数据存入数据库
            demoliteService.insertList(reserveManagementList);
        }

        String flag = act.getFlag();
        try {
            String comment = URLDecoder.decode(act.getComment(), "UTF-8");
            act.setComment(comment);
            if ("yes".equals(flag)) {

                //从redis中查看是否有在线开甲供材数据
                List<?> list = DataList.getList(reserveProcess.getProjectReserveId());
                List<MaterialInfo> infoList = new ArrayList<>();
                ShowList showList = null;
                MaterialInfo info = null;
                if ("".equals(drjgc) & "".equals(material)) {
                    j.setMsg("该项目没有甲供材清册");
                    j.setSuccess(false);
                    return j;
                }else if ("".equals(drjgc) & !"".equals(material)){
                    //将redis中的数据存入数据库   cg_material_data
                    for (int i=0;i<list.size();i++){
                        showList = (ShowList) list.get(i);
                        info = new MaterialInfo();
                        info.setProjectName(showList.getProjectName());
                        info.setMaterialCode(showList.getMaterialCode());
                        info.setMaterialName(showList.getMaterialDescription());
                        info.setExtendDescription(showList.getExtensionDescription());
                        info.setUnit(showList.getMdUnits());
                        info.setTotalCount(showList.getMdTotalAmount());
                        info.setWeightKg(showList.getMdSingleWeight());
                        info.setWeightTon(showList.getMdTotalWeight());
                        info.setSupplyType(showList.getMdTheParty());
                        info.setNote(showList.getMdText());
                        infoList.add(info);
                    }
                    //保存甲供材信息
                    reserveProcessService.saveList(infoList);
                    //修改项目设计单位上传文件部分
                    reserveProcessService.updateDesign(reserveProcess);
                    reserveProcessService.actDesignUnit(act, reserveProcess);

                    //设置带电作业信息表 相关字段值
                    Double allNum = reserveProcessService.getAllNum("500138348");
                    workService.updateSwitchNum(allNum == null ? "" : allNum + "");

//                    //获取新建土建包封数据总和
//                    double bfSum = 0.0;
//                    if (queryService.getTJBFData() != null){
//                        bfSum = bfSum + queryService.getTJBFData();
//
//                    }
//                    //获取新建土建基础数据总和
//                    double jcSum = 0.0;
//                    if (queryService.getTJJCData() != null){
//                        jcSum = jcSum + queryService.getTJJCData();
//
//                    }
//                    double divide = jcSum/bfSum;
//
//                    //获取所有的 物料编码，扩展描述，总量信息
//                    List<MaterialData> materialData = queryService.findAllCount();
//
//                    //现场浇筑清单
//                    Double decimal1 = 0.0;
//                    Double decimal2 = 0.0;
//                    Double decimal3 = 0.0;
//                    Double decimal4 = 0.0;
//                    Double decimal5 = 0.0;
//                    Double decimal6 = 0.0;
//
//                    //预制化清单
//                    Double decimal7 = 0.0;
//                    Double decimal8 = 0.0;
//                    Double decimal9 = 0.0;
//                    Double decimal10 = 0.0;
//                    Double decimal11 = 0.0;
//                    Double decimal12 = 0.0;
//                    Double decimal13 = 0.0;
//                    Double decimal14 = 0.0;
//                    Double decimal15 = 0.0;
//                    Double decimal16 = 0.0;
//                    Double decimal17 = 0.0;
//                    Double decimal18 = 0.0;
//                    Double decimal19 = 0.0;
//                    for (int i=0;i<materialData.size();i++){
//                        if (materialData.get(i).getMaterialCode().equals("乙供")){
//                            //现场浇筑清单
//                            if (materialData.get(i).getExtendDescription().equals("配农网用,整套杆,GNH31-13-B")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal1 = decimal1 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("GNH35-13；灌注桩")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal2 = decimal2 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("GNH39-13；灌注桩")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal3 = decimal3 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("GNH31-13；台阶式基础")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal4 = decimal4 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("GNH35-13；台阶式基础")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal5 = decimal5 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("GNH39-13；台阶式基础")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal6 = decimal6 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//
//                            //预制化清单
//                            if (materialData.get(i).getExtendDescription().equals("预制化排管，2×3（5+1），≤100kN")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal7 = decimal7 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("预制化排管，2×4（7+1），≤100kN")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal8 = decimal8 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("预制化排管，3×4（11+1），≤100kN")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal9 = decimal9 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("预制化排管，4×3（11+1），≤100kN")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal10 = decimal10 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("预制化排管，4×4（15+1），≤100kN")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal11 = decimal11 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("预制化排管，4×5（19+1），≤100kN")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal12 = decimal12 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("预制化直线井，3×2.0×1.9，人孔")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal13 = decimal13 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("预制化三通井，3×2.8×1.9，人孔")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal14 = decimal14 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("预制化八角井，4.0×4.0×1.9，人孔")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal15 = decimal15 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("两进两出环网箱基础预制，3.2×1.15×1.6")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal16 = decimal16 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("两进四出环网箱基础预制，4.0×1.15×1.6")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal17 = decimal17 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("紧凑型箱变基础预制，2.45×1.15×1.6")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal18 = decimal18 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//                            if (materialData.get(i).getExtendDescription().equals("标准型箱变基础预制，3.3×2.2×1.6")
//                                    & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
//                                decimal19 = decimal19 + Double.valueOf(materialData.get(i).getTotalCount());
//                            }
//
//                        }
//
//                    }
//                    /*materialData.forEach(da ->{
//                        if (da.getMaterialCode().equals("500128790")){
//                            String extendDescription = da.getExtendDescription();
//                            //使用switch
//                            switch (extendDescription){
//                                case "配农网用,整套杆,GNH31-13-B":
//                                    if (StringUtils.isNotEmpty(da.getTotalCount())){
//                                        decimal1.add(BigDecimal.valueOf(Double.valueOf(da.getTotalCount())));
//                                        break;
//                                    }
//                                    break;
//                                case "GNH35-13；灌注桩":
//                                    if (da.getTotalCount() != null){
//                                        decimal2.add(BigDecimal.valueOf(Double.valueOf(da.getTotalCount())));
//                                    }
//                                    break;
//                                case "GNH39-13；灌注桩":
//                                    if (da.getTotalCount() != null){
//                                        decimal3.add(BigDecimal.valueOf(Double.valueOf(da.getTotalCount())));
//                                    }
//                                    break;
//                                case "GNH31-13；台阶式基础":
//                                    if (da.getTotalCount() != null){
//                                        decimal4.add(BigDecimal.valueOf(Double.valueOf(da.getTotalCount())));
//                                    }
//                                    break;
//                                case "GNH35-13；台阶式基础":
//                                    if (da.getTotalCount() != null){
//                                        decimal5.add(BigDecimal.valueOf(Double.valueOf(da.getTotalCount())));
//                                    }
//                                    break;
//                                case "GNH39-13；台阶式基础":
//                                    if (da.getTotalCount() != null){
//                                        decimal6.add(BigDecimal.valueOf(Double.valueOf(da.getTotalCount())));
//                                    }
//                                    break;
//                            }
//                            if (extendDescription.equals("配农网用,整套杆,GNH31-13-B") & StringUtils.isNotEmpty(da.getTotalCount())){
//                                decimal1 = new BigDecimal(Double.valueOf(da.getTotalCount());
//                                decimal1.add(BigDecimal.valueOf(Double.valueOf(da.getTotalCount())));
//                            }
//
//                        }
//                    });*/
//
//                    //设置    现场浇筑清单数据
//                    String castInPlaceList = "";
//                    if (StringUtils.isNotEmpty(decimal1.toString()) & decimal1 != 0.0){
//                        castInPlaceList = decimal1.toString() + "基" + "配农网用,整套杆,GNH31-13-B";
//                    }
//                    if (StringUtils.isNotEmpty(decimal2.toString()) & decimal2 != 0.0){
//                        castInPlaceList = castInPlaceList + ";" + decimal2.toString() + "基" + "GNH35-13；灌注桩";
//                    }
//                    if (StringUtils.isNotEmpty(decimal3.toString()) & decimal3 != 0.0){
//                        castInPlaceList = castInPlaceList + ";" + decimal3.toString() + "基" + "GNH39-13；灌注桩";
//                    }
//                    if (StringUtils.isNotEmpty(decimal4.toString()) & decimal4 != 0.0){
//                        castInPlaceList = castInPlaceList + ";" + decimal4.toString() + "基" + "GNH31-13；台阶式基础";
//                    }
//                    if (StringUtils.isNotEmpty(decimal5.toString()) & decimal5 != 0.0){
//                        castInPlaceList = castInPlaceList + ";" + decimal5.toString() + "基" + "GNH35-13；台阶式基础";
//                    }
//                    if (StringUtils.isNotEmpty(decimal6.toString()) & decimal6 != 0.0){
//                        castInPlaceList = castInPlaceList + ";" + decimal6.toString() + "基" + "GNH39-13；台阶式基础";
//                    }
//
//                    String designList = "";
//                    if (StringUtils.isNotEmpty(decimal7.toString()) & decimal7 != 0.0){
//                        designList = decimal7.toString() + "米" + "预制化排管，2×3（5+1），≤100kN";
//                    }
//                    if (StringUtils.isNotEmpty(decimal8.toString()) & decimal8 != 0.0){
//                        designList = designList + ";" + decimal8.toString() + "米" + "预制化排管，2×4（7+1），≤100kN";
//                    }
//                    if (StringUtils.isNotEmpty(decimal9.toString()) & decimal9 != 0.0){
//                        designList = designList + ";" + decimal9.toString() + "米" + "预制化排管，3×4（11+1），≤100kN";
//                    }
//                    if (StringUtils.isNotEmpty(decimal10.toString()) & decimal10 != 0.0){
//                        designList = designList + ";" + decimal10.toString() + "米" + "预制化排管，4×3（11+1），≤100kN";
//                    }
//                    if (StringUtils.isNotEmpty(decimal11.toString()) & decimal11 != 0.0){
//                        designList = designList + ";" + decimal11.toString() + "米" + "预制化排管，4×4（15+1），≤100kN";
//                    }
//                    if (StringUtils.isNotEmpty(decimal12.toString()) & decimal12 != 0.0){
//                        designList = designList + ";" + decimal12.toString() + "米" + "预制化排管，4×5（19+1），≤100kN";
//                    }
//                    if (StringUtils.isNotEmpty(decimal13.toString()) & decimal13 != 0.0){
//                        designList = designList + ";" + decimal13.toString() + "座" + "预制化直线井，3×2.0×1.9，人孔";
//                    }
//                    if (StringUtils.isNotEmpty(decimal14.toString()) & decimal14 != 0.0){
//                        designList = designList + ";" + decimal14.toString() + "座" + "预制化三通井，3×2.8×1.9，人孔";
//                    }
//                    if (StringUtils.isNotEmpty(decimal15.toString()) & decimal15 != 0.0){
//                        designList = designList + ";" + decimal15.toString() + "座" + "预制化八角井，4.0×4.0×1.9，人孔";
//                    }
//                    if (StringUtils.isNotEmpty(decimal16.toString()) & decimal16 != 0.0){
//                        designList = designList + ";" + decimal16.toString() + "座" + "两进两出环网箱基础预制，3.2×1.15×1.6";
//                    }
//                    if (StringUtils.isNotEmpty(decimal17.toString()) & decimal17 != 0.0){
//                        designList = designList + ";" + decimal17.toString() + "座" + "两进四出环网箱基础预制，4.0×1.15×1.6";
//                    }
//                    if (StringUtils.isNotEmpty(decimal18.toString()) & decimal18 != 0.0){
//                        designList = designList + ";" + decimal18.toString() + "座" + "紧凑型箱变基础预制，2.45×1.15×1.6";
//                    }
//                    if (StringUtils.isNotEmpty(decimal19.toString()) & decimal19 != 0.0){
//                        designList = designList + ";" + decimal19.toString() + "座" + "标准型箱变基础预制，3.3×2.2×1.6";
//                    }
//
//                    if (divide >0 ){
//                        //修改  是否含新建土建基础/包封 为是
//                        preconstructService.updateMetion("是",castInPlaceList,designList);
//                    }else {
//                        preconstructService.updateMetion("否",castInPlaceList,designList);
//                    }

                }else {
                    //修改项目设计单位上传文件部分
                    reserveProcessService.updateDesign(reserveProcess);
                    reserveProcessService.actDesignUnit(act, reserveProcess);
                }
            } else {
                reserveProcessService.actDesignUnit(act, reserveProcess);
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        j.setMsg("审批成功");
        return j;
    }

    /**
     * 储备流程，文件显示管理
     */
    @ResponseBody
    @RequestMapping(value = "allUploadData")
    public Map<String, Object> allUploadData(ReserveSummaryProcess reserveProcess, HttpServletRequest request, HttpServletResponse response, Model model) {
        Page<ReserveSummaryProcess> page = reserveProcessService.findAllUploadPage(new Page<ReserveSummaryProcess>(request, response), reserveProcess);
        //当判定系统为linux的时候
        if (Global.SYS_TYPE.equals("2")) {
            List<ReserveSummaryProcess> list = page.getList();
            for (ReserveSummaryProcess upload :
                    list) {
                String a = "";
                String b = "";
                String c = "";
                String d = "";
                String path = upload.getBudgetStatement();
                if (null != path && !"".equals(path)) {
                    String[] split = path.split("\\|");
                    for (int i = 0; i < split.length; i++) {
                        a += "http://" + request.getServerName() + split[i] + "|";
                    }
                    upload.setBudgetStatement(a);
                }

                String projectProposal = upload.getProjectProposal();
                if (null != projectProposal && !"".equals(projectProposal)) {
                    String[] split1 = projectProposal.split("\\|");
                    for (int i = 0; i < split1.length; i++) {
                        b += "http://" + request.getServerName() + split1[i] + "|";
                    }
                    upload.setProjectProposal(b);
                }

                String drawings = upload.getDrawings();
                if (null != drawings && !"".equals(drawings)) {
                    String[] split2 = drawings.split("\\|");
                    for (int i = 0; i < split2.length; i++) {
                        c += "http://" + request.getServerName() + split2[i] + "|";
                    }
                    upload.setDrawings(c);
                }

                String drawingSpecification = upload.getDrawingSpecification();
                if (null != drawingSpecification && !"".equals(drawingSpecification)) {
                    String[] split3 = drawingSpecification.split("\\|");
                    for (int i = 0; i < split3.length; i++) {
                        d += "http://" + request.getServerName() + split3[i] + "|";
                    }
                    upload.setDrawingSpecification(d);
                }
            }
        }
        return getBootstrapData(page);
    }

    /**
     * 甲供材 列表数据
     */
    @ResponseBody
    @RequestMapping(value = "materialData")
    public Map<String, Object> data(MaterialInfo materialInfo, HttpServletRequest request, HttpServletResponse response, Model model) {
        Page<MaterialInfo> page = reserveProcessService.findMaterialPage(new Page<MaterialInfo>(request, response), materialInfo);
        return getBootstrapData(page);
    }

    @ResponseBody
    @RequestMapping(value = "exportAct")
    public AjaxJson exportAct(String projectName, ReserveProcess reserveProcess, HttpServletRequest request, HttpServletResponse response) {
        AjaxJson j = new AjaxJson();
        try {
            String fileName = "甲供材清册" + DateUtils.getDate("yyyyMMddHHmmss") + ".xlsx";
            List<MaterialInfo> list = reserveProcessService.findMaterialActiviti(projectName);
            new ExportExcel("甲供材清册", MaterialInfo.class).setDataList(list).write(response, fileName).dispose();
            j.setSuccess(true);
            j.setMsg("导出成功！");
            return j;
        } catch (Exception e) {
            j.setSuccess(false);
            j.setMsg("导出甲供材清册失败！失败信息：" + e.getMessage());
        }
        return j;
    }

    /***
     * 项目经理审图（储备专职/配网项目经理）
     * */
    @ResponseBody
    @RequestMapping(value = "actDrawingReview")
    public AjaxJson actDrawingReview(Act act,ReserveSummaryProcess process) {
        AjaxJson j = new AjaxJson();
        try {
            String comment = URLDecoder.decode(act.getComment(), "UTF-8");
            act.setComment(comment);
            reserveProcessService.actDrawingReview(act,process);
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }
        j.setMsg("审批成功");
        return j;
    }

    /***
     * 联合审图（储备专职/配网项目经理）
     * */
    @ResponseBody
    @RequestMapping(value = "actDrawingReviewTest")
    public AjaxJson actDrawingReviewTest(Act act,ReserveSummaryProcess process) {
        AjaxJson j = new AjaxJson();
        try {
            String comment = URLDecoder.decode(act.getComment(), "UTF-8");
            act.setComment(comment);
            reserveProcessService.actDrawingReviewTest(act,process);
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        j.setMsg("审批成功");
        return j;
    }

    /***
     * 技经人员审核
     * */
    @ResponseBody
    @RequestMapping(value = "actBudgetUnit")
    public AjaxJson actBudgetUnit(Act act, ReserveSummaryProcess reserveProcess) throws Exception {
        AjaxJson j = new AjaxJson();

        try {
            String comment = URLDecoder.decode(act.getComment(), "UTF-8");
            act.setComment(comment);
            reserveProcessService.actBudgetUnit(act,reserveProcess);
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        j.setMsg("审批成功");
        return j;
    }
}
