package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.web;

import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ReservePreconstruction;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.ReservePreconstructService;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils.ReserveProcessProjectExportUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils.ReserveProcessProjectProUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.MaterialData;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.service.EnginnerQueryService;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 储备项目预土建制化信息 controller
 * @author: 王强
 * @create: 2022-07-26 09:22
 **/
@Controller
@RequestMapping(value = "${adminPath}/cg/reservemanagementcenter/reservePreconstruct")
public class ReservePreconstructController extends BaseController {

    @Autowired
    private ReservePreconstructService structService;

    @Autowired
    private EnginnerQueryService queryService;

    @ModelAttribute
    public ReservePreconstruction get(@RequestParam(required = false) String id) {
        ReservePreconstruction entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = structService.get(id);
        }
        if (entity == null) {
            entity = new ReservePreconstruction();
        }
        return entity;
    }

    /**
     * 项目储备信息列表页面
     * @param reserveManagement
     * @param model
     * @return
     */
    @RequiresPermissions("cg:reservemanagementcenter:reservePreconstruct:list")
    @RequestMapping(value = "skipList")
    public String skipList(ReservePreconstruction reserveManagement, Model model) {
        model.addAttribute("reserveManagement", reserveManagement);
        return "modules/cg/reservemanagementcenter/reserveManage/reservePreconstruct/reserveManagementInformation";
    }



    /**
     * 项目储备信息数据列表
     * @param reserveManagement
     * @param request
     * @param response
     * @param model
     * @return
     */
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:reservePreconstruct:list")
    @RequestMapping(value = "list")
    public Map<String, Object> basicData(ReservePreconstruction reserveManagement, HttpServletRequest request, HttpServletResponse response, Model model) {

        Page<ReservePreconstruction> page = structService.findPage(new Page<ReservePreconstruction>(request, response), reserveManagement);
        List<ReservePreconstruction> list = page.getList();
        List<ReservePreconstruction> preList = new ArrayList<>();
        for (ReservePreconstruction pre : list) {

            //根据projectReserveId查出流程表的proc_ins_id
            String procInsId = structService.getByProjectReserveId(pre.getProjectReserveId());
            //根据procInsId查出历史流程名称和时间
            List<History> histories = structService.getHistoryByExecuteId(procInsId);
            //当size>0时待办有历史流程，
            if (histories.size()>0){
                //根据proc_ins_id去运行时任务节点表（act_ru_task）中查出当前流程名称
                String name = structService.getByExecuteId(procInsId);
                //设置项目进度
                pre.setReserveProgress(name);
            }

            //cg_material_data
            //从甲供材数据表中查出所有的数据
            //获取所有的 物料编码，扩展描述，总量信息
            List<MaterialData> materialData = queryService.findAllCount();

            //获取新建土建包封数据总和
            double bfSum = 0.0;
            if (queryService.getTJBFData() != null){
                bfSum = bfSum + queryService.getTJBFData();

            }
            //获取新建土建基础数据总和
            double jcSum = 0.0;
            if (queryService.getTJJCData() != null){
                jcSum = jcSum + queryService.getTJJCData();

            }
            double divide = jcSum/bfSum;

            //现场浇筑清单
            Double decimal1 = 0.0;
            Double decimal2 = 0.0;
            Double decimal3 = 0.0;
            Double decimal4 = 0.0;
            Double decimal5 = 0.0;
            Double decimal6 = 0.0;

            //预制化清单
            Double decimal7 = 0.0;
            Double decimal8 = 0.0;
            Double decimal9 = 0.0;
            Double decimal10 = 0.0;
            Double decimal11 = 0.0;
            Double decimal12 = 0.0;
            Double decimal13 = 0.0;
            Double decimal14 = 0.0;
            Double decimal15 = 0.0;
            Double decimal16 = 0.0;
            Double decimal17 = 0.0;
            Double decimal18 = 0.0;
            Double decimal19 = 0.0;
            for (int i=0;i<materialData.size();i++){
                if (materialData.get(i).getMaterialCode().equals("乙供")){
                    //现场浇筑清单
                    if (materialData.get(i).getExtendDescription().equals("配农网用,整套杆,GNH31-13-B")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal1 = decimal1 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH35-13；灌注桩")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal2 = decimal2 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH39-13；灌注桩")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal3 = decimal3 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH31-13；台阶式基础")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal4 = decimal4 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH35-13；台阶式基础")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal5 = decimal5 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH39-13；台阶式基础")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal6 = decimal6 + Double.valueOf(materialData.get(i).getTotalCount());
                    }

                    //预制化清单
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，2×3（5+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal7 = decimal7 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，2×4（7+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal8 = decimal8 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，3×4（11+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal9 = decimal9 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，4×3（11+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal10 = decimal10 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，4×4（15+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal11 = decimal11 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，4×5（19+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal12 = decimal12 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化直线井，3×2.0×1.9，人孔")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal13 = decimal13 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化三通井，3×2.8×1.9，人孔")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal14 = decimal14 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化八角井，4.0×4.0×1.9，人孔")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal15 = decimal15 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("两进两出环网箱基础预制，3.2×1.15×1.6")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal16 = decimal16 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("两进四出环网箱基础预制，4.0×1.15×1.6")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal17 = decimal17 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("紧凑型箱变基础预制，2.45×1.15×1.6")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal18 = decimal18 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("标准型箱变基础预制，3.3×2.2×1.6")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal19 = decimal19 + Double.valueOf(materialData.get(i).getTotalCount());
                    }

                }

            }

            //设置    现场浇筑清单数据
            String castInPlaceList = "";
            if (StringUtils.isNotEmpty(decimal1.toString()) & decimal1 != 0.0){
                castInPlaceList = decimal1.toString() + "基" + "配农网用,整套杆,GNH31-13-B";
            }
            if (StringUtils.isNotEmpty(decimal2.toString()) & decimal2 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal2.toString() + "基" + "GNH35-13；灌注桩";
            }
            if (StringUtils.isNotEmpty(decimal3.toString()) & decimal3 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal3.toString() + "基" + "GNH39-13；灌注桩";
            }
            if (StringUtils.isNotEmpty(decimal4.toString()) & decimal4 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal4.toString() + "基" + "GNH31-13；台阶式基础";
            }
            if (StringUtils.isNotEmpty(decimal5.toString()) & decimal5 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal5.toString() + "基" + "GNH35-13；台阶式基础";
            }
            if (StringUtils.isNotEmpty(decimal6.toString()) & decimal6 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal6.toString() + "基" + "GNH39-13；台阶式基础";
            }

            String designList = "";
            if (StringUtils.isNotEmpty(decimal7.toString()) & decimal7 != 0.0){
                designList = decimal7.toString() + "米" + "预制化排管，2×3（5+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal8.toString()) & decimal8 != 0.0){
                designList = designList + ";" + decimal8.toString() + "米" + "预制化排管，2×4（7+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal9.toString()) & decimal9 != 0.0){
                designList = designList + ";" + decimal9.toString() + "米" + "预制化排管，3×4（11+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal10.toString()) & decimal10 != 0.0){
                designList = designList + ";" + decimal10.toString() + "米" + "预制化排管，4×3（11+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal11.toString()) & decimal11 != 0.0){
                designList = designList + ";" + decimal11.toString() + "米" + "预制化排管，4×4（15+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal12.toString()) & decimal12 != 0.0){
                designList = designList + ";" + decimal12.toString() + "米" + "预制化排管，4×5（19+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal13.toString()) & decimal13 != 0.0){
                designList = designList + ";" + decimal13.toString() + "座" + "预制化直线井，3×2.0×1.9，人孔";
            }
            if (StringUtils.isNotEmpty(decimal14.toString()) & decimal14 != 0.0){
                designList = designList + ";" + decimal14.toString() + "座" + "预制化三通井，3×2.8×1.9，人孔";
            }
            if (StringUtils.isNotEmpty(decimal15.toString()) & decimal15 != 0.0){
                designList = designList + ";" + decimal15.toString() + "座" + "预制化八角井，4.0×4.0×1.9，人孔";
            }
            if (StringUtils.isNotEmpty(decimal16.toString()) & decimal16 != 0.0){
                designList = designList + ";" + decimal16.toString() + "座" + "两进两出环网箱基础预制，3.2×1.15×1.6";
            }
            if (StringUtils.isNotEmpty(decimal17.toString()) & decimal17 != 0.0){
                designList = designList + ";" + decimal17.toString() + "座" + "两进四出环网箱基础预制，4.0×1.15×1.6";
            }
            if (StringUtils.isNotEmpty(decimal18.toString()) & decimal18 != 0.0){
                designList = designList + ";" + decimal18.toString() + "座" + "紧凑型箱变基础预制，2.45×1.15×1.6";
            }
            if (StringUtils.isNotEmpty(decimal19.toString()) & decimal19 != 0.0){
                designList = designList + ";" + decimal19.toString() + "座" + "标准型箱变基础预制，3.3×2.2×1.6";
            }

            if (divide >0 ){
                //修改  是否含新建土建基础/包封 为是
                pre.setDesignCivilFoundation("是");
                pre.setCastInPlaceList(castInPlaceList);
                pre.setDesignList(designList);
            }else {
                pre.setDesignCivilFoundation("否");
                pre.setCastInPlaceList(castInPlaceList);
                pre.setDesignList(designList);
            }

            preList.add(pre);
        }

        return getBootstrapData(page);
    }


    /**
     * 查看表单页面
     */
    @RequiresPermissions(value={"cg:reservemanagementcenter:reservePreconstruct:view"},logical= Logical.OR)
    @RequestMapping(value = "view")
    public String view(ReservePreconstruction reserveManagement, Model model) {
        model.addAttribute("reserveManagement", reserveManagement);
        return "modules/cg/reservemanagementcenter/reserveManage/reservePreconstruct/reserveManagementView";
    }


    /**
     * 专职人员保存表单
     * @param reserveManagement
     * @return
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:reservemanagementcenter:reservePreconstruct:add"},logical=Logical.OR)
    @RequestMapping(value = "save")
    public AjaxJson save(ReservePreconstruction reserveManagement){
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(reserveManagement);
        if (StringUtils.isNotBlank(errMsg)){
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }
        //新增或编辑表单保存
        structService.save(reserveManagement);//保存
        j.setSuccess(true);
        j.setMsg("保存储备项目基本信息成功");
        return j;
    }


    /**
     * 专职人员修改表单
     * @param reserveManagement
     * @return
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:reservemanagementcenter:reservePreconstruct:edit"},logical=Logical.OR)
    @RequestMapping(value = "update")
    public AjaxJson update(ReservePreconstruction reserveManagement){
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(reserveManagement);
        if (StringUtils.isNotBlank(errMsg)){
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }
        //新增或编辑表单保存
        structService.update(reserveManagement);
        j.setSuccess(true);
        j.setMsg("修改储备项目基本信息成功");
        return j;
    }

    /**
     * 导入Excel数据
     */
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:reservePreconstruct:import")
    @RequestMapping(value = "import")
    public AjaxJson importBasic(@RequestParam("file") MultipartFile file, HttpServletResponse response, HttpServletRequest request) {
        AjaxJson j = new AjaxJson();
        try {
            ImportUtil importUtil = new ImportUtil(file, 0, 0);

            //从数据库中查出所有的 项目储备编号
            List<String> proIdList = structService.getAllProId();

            //从基本数据表中查出所有的 项目储备编号
            List<String> proIdList2 = structService.getAllProId2();

            //获取导入表格所有数据
            List<ReservePreconstruction> reserveManagementList = ReserveProcessProjectProUtil.getPreconstUtil(importUtil,proIdList,proIdList2);
            //查询已有的参数数据 并分类返回已存在数据和未存在数据
            Map map = structService.getExistProjectList(reserveManagementList);
            //未存在数据
            List<ReservePreconstruction> withoutList = (List<ReservePreconstruction>) map.get("without");
            //已存在数据
            List<ReservePreconstruction> existList = (List<ReservePreconstruction>) map.get("exist");

            //对未存在的数据进行批量导入
            if(withoutList.size()>0){
                structService.insertList(withoutList);
            }

            //对已存在的数据进行修改
            if(existList.size()>0){
                for (ReservePreconstruction reserveManagement : existList) {
                    structService.update(reserveManagement);
                }
            }
            int i = withoutList.size() + existList.size();
            j.setMsg("已成功导入" + i + "条项目储备信息记录");

        } catch (Exception e) {
            j.setSuccess(false);
            j.setMsg("导入项目储备信息失败！失败信息：" + e.getMessage());
        }
        return j;
    }


    //导出excel
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:reservePreconstruct:export")
    @RequestMapping(value = "export")
    public void exportExcel(ReservePreconstruction reserveManagement, HttpServletRequest request, HttpServletResponse response) {
        List<ReservePreconstruction> list = structService.exportFindList(reserveManagement);

        List<ReservePreconstruction> preList = new ArrayList<>();
        for (ReservePreconstruction pre : list) {

            //根据projectReserveId查出流程表的proc_ins_id
            String procInsId = structService.getByProjectReserveId(pre.getProjectReserveId());
            //根据procInsId查出历史流程名称和时间
            List<History> histories = structService.getHistoryByExecuteId(procInsId);
            //当size>0时待办有历史流程，
            if (histories.size()>0){
                //根据proc_ins_id去运行时任务节点表（act_ru_task）中查出当前流程名称
                String name = structService.getByExecuteId(procInsId);
                //设置项目进度
                pre.setReserveProgress(name);
            }

            //cg_material_data
            //从甲供材数据表中查出所有的数据
            //获取所有的 物料编码，扩展描述，总量信息
            List<MaterialData> materialData = queryService.findAllCount();

            //获取新建土建包封数据总和
            double bfSum = 0.0;
            if (queryService.getTJBFData() != null){
                bfSum = bfSum + queryService.getTJBFData();

            }
            //获取新建土建基础数据总和
            double jcSum = 0.0;
            if (queryService.getTJJCData() != null){
                jcSum = jcSum + queryService.getTJJCData();

            }
            double divide = jcSum/bfSum;

            //现场浇筑清单
            Double decimal1 = 0.0;
            Double decimal2 = 0.0;
            Double decimal3 = 0.0;
            Double decimal4 = 0.0;
            Double decimal5 = 0.0;
            Double decimal6 = 0.0;

            //预制化清单
            Double decimal7 = 0.0;
            Double decimal8 = 0.0;
            Double decimal9 = 0.0;
            Double decimal10 = 0.0;
            Double decimal11 = 0.0;
            Double decimal12 = 0.0;
            Double decimal13 = 0.0;
            Double decimal14 = 0.0;
            Double decimal15 = 0.0;
            Double decimal16 = 0.0;
            Double decimal17 = 0.0;
            Double decimal18 = 0.0;
            Double decimal19 = 0.0;
            for (int i=0;i<materialData.size();i++){
                if (materialData.get(i).getMaterialCode().equals("乙供")){
                    //现场浇筑清单
                    if (materialData.get(i).getExtendDescription().equals("配农网用,整套杆,GNH31-13-B")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal1 = decimal1 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH35-13；灌注桩")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal2 = decimal2 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH39-13；灌注桩")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal3 = decimal3 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH31-13；台阶式基础")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal4 = decimal4 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH35-13；台阶式基础")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal5 = decimal5 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("GNH39-13；台阶式基础")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal6 = decimal6 + Double.valueOf(materialData.get(i).getTotalCount());
                    }

                    //预制化清单
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，2×3（5+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal7 = decimal7 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，2×4（7+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal8 = decimal8 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，3×4（11+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal9 = decimal9 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，4×3（11+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal10 = decimal10 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，4×4（15+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal11 = decimal11 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化排管，4×5（19+1），≤100kN")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal12 = decimal12 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化直线井，3×2.0×1.9，人孔")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal13 = decimal13 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化三通井，3×2.8×1.9，人孔")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal14 = decimal14 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("预制化八角井，4.0×4.0×1.9，人孔")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal15 = decimal15 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("两进两出环网箱基础预制，3.2×1.15×1.6")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal16 = decimal16 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("两进四出环网箱基础预制，4.0×1.15×1.6")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal17 = decimal17 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("紧凑型箱变基础预制，2.45×1.15×1.6")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal18 = decimal18 + Double.valueOf(materialData.get(i).getTotalCount());
                    }
                    if (materialData.get(i).getExtendDescription().equals("标准型箱变基础预制，3.3×2.2×1.6")
                            & StringUtils.isNotEmpty(materialData.get(i).getTotalCount())){
                        decimal19 = decimal19 + Double.valueOf(materialData.get(i).getTotalCount());
                    }

                }

            }

            //设置    现场浇筑清单数据
            String castInPlaceList = "";
            if (StringUtils.isNotEmpty(decimal1.toString()) & decimal1 != 0.0){
                castInPlaceList = decimal1.toString() + "基" + "配农网用,整套杆,GNH31-13-B";
            }
            if (StringUtils.isNotEmpty(decimal2.toString()) & decimal2 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal2.toString() + "基" + "GNH35-13；灌注桩";
            }
            if (StringUtils.isNotEmpty(decimal3.toString()) & decimal3 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal3.toString() + "基" + "GNH39-13；灌注桩";
            }
            if (StringUtils.isNotEmpty(decimal4.toString()) & decimal4 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal4.toString() + "基" + "GNH31-13；台阶式基础";
            }
            if (StringUtils.isNotEmpty(decimal5.toString()) & decimal5 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal5.toString() + "基" + "GNH35-13；台阶式基础";
            }
            if (StringUtils.isNotEmpty(decimal6.toString()) & decimal6 != 0.0){
                castInPlaceList = castInPlaceList + ";" + decimal6.toString() + "基" + "GNH39-13；台阶式基础";
            }

            String designList = "";
            if (StringUtils.isNotEmpty(decimal7.toString()) & decimal7 != 0.0){
                designList = decimal7.toString() + "米" + "预制化排管，2×3（5+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal8.toString()) & decimal8 != 0.0){
                designList = designList + ";" + decimal8.toString() + "米" + "预制化排管，2×4（7+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal9.toString()) & decimal9 != 0.0){
                designList = designList + ";" + decimal9.toString() + "米" + "预制化排管，3×4（11+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal10.toString()) & decimal10 != 0.0){
                designList = designList + ";" + decimal10.toString() + "米" + "预制化排管，4×3（11+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal11.toString()) & decimal11 != 0.0){
                designList = designList + ";" + decimal11.toString() + "米" + "预制化排管，4×4（15+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal12.toString()) & decimal12 != 0.0){
                designList = designList + ";" + decimal12.toString() + "米" + "预制化排管，4×5（19+1），≤100kN";
            }
            if (StringUtils.isNotEmpty(decimal13.toString()) & decimal13 != 0.0){
                designList = designList + ";" + decimal13.toString() + "座" + "预制化直线井，3×2.0×1.9，人孔";
            }
            if (StringUtils.isNotEmpty(decimal14.toString()) & decimal14 != 0.0){
                designList = designList + ";" + decimal14.toString() + "座" + "预制化三通井，3×2.8×1.9，人孔";
            }
            if (StringUtils.isNotEmpty(decimal15.toString()) & decimal15 != 0.0){
                designList = designList + ";" + decimal15.toString() + "座" + "预制化八角井，4.0×4.0×1.9，人孔";
            }
            if (StringUtils.isNotEmpty(decimal16.toString()) & decimal16 != 0.0){
                designList = designList + ";" + decimal16.toString() + "座" + "两进两出环网箱基础预制，3.2×1.15×1.6";
            }
            if (StringUtils.isNotEmpty(decimal17.toString()) & decimal17 != 0.0){
                designList = designList + ";" + decimal17.toString() + "座" + "两进四出环网箱基础预制，4.0×1.15×1.6";
            }
            if (StringUtils.isNotEmpty(decimal18.toString()) & decimal18 != 0.0){
                designList = designList + ";" + decimal18.toString() + "座" + "紧凑型箱变基础预制，2.45×1.15×1.6";
            }
            if (StringUtils.isNotEmpty(decimal19.toString()) & decimal19 != 0.0){
                designList = designList + ";" + decimal19.toString() + "座" + "标准型箱变基础预制，3.3×2.2×1.6";
            }

            if (divide >0 ){
                //修改  是否含新建土建基础/包封 为是
                pre.setDesignCivilFoundation("是");
                pre.setCastInPlaceList(castInPlaceList);
                pre.setDesignList(designList);
            }else {
                pre.setDesignCivilFoundation("否");
                pre.setCastInPlaceList(castInPlaceList);
                pre.setDesignList(designList);
            }


            preList.add(pre);
        }

        //生成序列号
        int i = 1;
        for (ReservePreconstruction s : preList) {
            s.setId(String.valueOf(i));
            i++;
        }

        ReserveProcessProjectExportUtil util = ReserveProcessProjectExportUtil.getOne();
        XSSFWorkbook workbook = util.getWorkbook("preconstruct");
        util.exportPrecons(response,workbook,preList);
    }


    /**
     * 专职人员增加，编辑表单页面
     * @param reserveManagement
     * @param model
     * @return
     */
    @RequiresPermissions(value={"cg:reservemanagementcenter:reservePreconstruct:add","cg:reservemanagementcenter:reservePreconstruct:edit"},logical= Logical.OR)
    @RequestMapping(value = "form")
    public String form(ReservePreconstruction reserveManagement, Model model) {
        //根据projectReserveId查出流程表的proc_ins_id
        String procInsId = structService.getByProjectReserveId(reserveManagement.getProjectReserveId());
        //根据procInsId查出历史流程名称和时间
        List<History> histories = structService.getHistoryByExecuteId(procInsId);
        //当size>0时待办有历史流程，
        if (histories.size()>0){
            //根据proc_ins_id去运行时任务节点表（act_ru_task）中查出当前流程名称
            String name = structService.getByExecuteId(procInsId);
            //设置项目进度
            reserveManagement.setReserveProgress(name);
        }else {
            reserveManagement.setReserveProgress("");
        }
        model.addAttribute("reserveManagement", reserveManagement);
        //判断id是否为空 如果未空则为新增 否则为修改
        if(StringUtils.isBlank(reserveManagement.getId())){
            return "modules/cg/reservemanagementcenter/reserveManage/reservePreconstruct/reserveManagementForm";
        }
        return "modules/cg/reservemanagementcenter/reserveManage/reservePreconstruct/reserveManagementModifyByzz";
    }
}
