package com.jeeplus.modules.sg.balancedlibrary.transitMaterialGoods.entity;

import com.jeeplus.common.utils.excel.annotation.ExcelField;
import com.jeeplus.core.persistence.DataEntity;

import java.util.Date;

/**
 * 在途物资Entity
 * @author: 王强
 * @create: 2022-08-30 14:07
 **/
public class TransitMaterialGoods extends DataEntity<TransitMaterialGoods> {

    private String serialNumber;    //序号
    private String externalContractNumber;  //外部合同编号
    private String factory; //工厂
    private String factoryName; //工厂名称
    private String batch;   //批次
    private String materialCode;    //物料编码
    private String materialDescription; //物料描述
    private String contractName;    //合同
    private String contractLineItem;    //合同行项目
    private String contractCount;   //合同数量
    private String unit;    //度量单位文本
    private String unitPrice;   //单价
    private String money;   //金额
    private String supplierCode;    //供应商编码
    private String supplierName;    //供应商名称
    private String purchaseOrder;   //采购订单
    private String orderLineItem;   //订单行项目
    private String netPurchaseOrderPrice;   //采购订单净价
    private String purchaseApplicationNo;   //采购申请号
    private String projectOfPurchasingApplicantBank;    //采购申请行项目
    private String purchaseApplicationQuantity; //采购申请数量
    private String orderUnit;   //订单单位
    private String materialCompanySO;   //物资公司SO
    private String soLineItem;//    SO项目行
    private String materialCompanyPO;//物资公司PO
    private String poLineItem;//    PO项目行
    private Date contractPlannedDeliveryDate; //合同计划交货日期
    private String deliveryScheduleOfTheDeliveryOrderIsPlanned; //配送单计划交货期
    private String quantityDelivered;   //已交货数量
    private String materialDocument103;    //103物料凭证
    private Date postingDate103; //103过账日期
    private String electronicAcceptanceReport;  //电子验收报告
    private String electronicAcceptanceReportStatus;    //电子验收报告审批状态
    private Date electronicAcceptanceReportDate;//电子验收报告审批日期
    private String materialDocument105;    //105物料凭证
    private Date postingDate105; //105过账日期
    private String arrivalRegistrant;   //到货登记人
    private String demandForTheUnit;    //需求单位
    private String requirementUnitDescription;  //需求单位描述
    private String deliveryPlace;   //配送地点
    private String distributionLocationDescription; //配送地点描述
    private String drawersCode; //出票方编码
    private String drawersName; //出票方名称
    private String supplierInvoice;//供应商发票
    private Date dateOfIssue;   //开票日期
    private Date payTheTicketDate;  //交票日期
    private String invoiceNumber;//发票数量
    private String invoiceCheckQuantity;    //发票校验数量
    private String invoiceAmount;   //发票金额
    private String invoiceStatus;   //发票状态
    private String taxCode; //税码
    private String assessmentType;//评估类型、
    private String moneyAttribute;//资金属性
    private String propertyRightAttribute;//产权属性
    private String theRatioOfPayment;//付款比例
    private String advancePayment;//预付款
    private String cashOnDelivery;//到货款
    private String putMoney;//投运款
    private String qualityAssuranceModel;//质保款
    private String theMunicipalTerritory;//市级属地
    private String amountOfApplicationForPayment;//申请付款金额
    private String amountOfInventory;//入库金额
    private String forTheAwb;//投运单号
    private String waybillStatus;//投运状态
    private String qualityPolicyNo;//质保单号
    private String pledgedPolicyStatus;//质保单状态
    private String guaranteePeriod;//质保期
    private String planner;//计划编制人

    @ExcelField(title = "序号", align = 2, sort = 1)
    public String getSerialNumber() {
        return serialNumber;
    }
    @ExcelField(title = "外部合同编号", align = 2, sort = 2)
    public String getExternalContractNumber() {
        return externalContractNumber;
    }
    @ExcelField(title = "工厂", align = 2, sort = 3)
    public String getFactory() {
        return factory;
    }
    @ExcelField(title = "工厂名称", align = 2, sort = 4)
    public String getFactoryName() {
        return factoryName;
    }
    @ExcelField(title = "批次", align = 2, sort = 5)
    public String getBatch() {
        return batch;
    }
    @ExcelField(title = "物料编码", align = 2, sort = 6)
    public String getMaterialCode() {
        return materialCode;
    }
    @ExcelField(title = "物料描述", align = 2, sort = 7)
    public String getMaterialDescription() {
        return materialDescription;
    }
    @ExcelField(title = "合同", align = 2, sort = 8)
    public String getContractName() {
        return contractName;
    }
    @ExcelField(title = "合同行项目", align = 2, sort = 9)
    public String getContractLineItem() {
        return contractLineItem;
    }
    @ExcelField(title = "合同数量", align = 2, sort = 10)
    public String getContractCount() {
        return contractCount;
    }
    @ExcelField(title = "度量单位文本", align = 2, sort = 11)
    public String getUnit() {
        return unit;
    }
    @ExcelField(title = "单价", align = 2, sort = 12)
    public String getUnitPrice() {
        return unitPrice;
    }
    @ExcelField(title = "金额", align = 2, sort = 13)
    public String getMoney() {
        return money;
    }
    @ExcelField(title = "供应商编码", align = 2, sort = 14)
    public String getSupplierCode() {
        return supplierCode;
    }
    @ExcelField(title = "供应商名称", align = 2, sort = 15)
    public String getSupplierName() {
        return supplierName;
    }
    @ExcelField(title = "采购订单", align = 2, sort = 16)
    public String getPurchaseOrder() {
        return purchaseOrder;
    }
    @ExcelField(title = "订单行项目", align = 2, sort = 17)
    public String getOrderLineItem() {
        return orderLineItem;
    }
    @ExcelField(title = "采购订单净价", align = 2, sort = 18)
    public String getNetPurchaseOrderPrice() {
        return netPurchaseOrderPrice;
    }
    @ExcelField(title = "采购申请号", align = 2, sort = 19)
    public String getPurchaseApplicationNo() {
        return purchaseApplicationNo;
    }
    @ExcelField(title = "采购申请行项目", align = 2, sort = 20)
    public String getProjectOfPurchasingApplicantBank() {
        return projectOfPurchasingApplicantBank;
    }
    @ExcelField(title = "采购申请数量", align = 2, sort = 21)
    public String getPurchaseApplicationQuantity() {
        return purchaseApplicationQuantity;
    }
    @ExcelField(title = "订单单位", align = 2, sort = 22)
    public String getOrderUnit() {
        return orderUnit;
    }
    @ExcelField(title = "物资公司SO", align = 2, sort = 23)
    public String getMaterialCompanySO() {
        return materialCompanySO;
    }
    @ExcelField(title = "SO项目行", align = 2, sort = 24)
    public String getSoLineItem() {
        return soLineItem;
    }
    @ExcelField(title = "物资公司PO", align = 2, sort = 25)
    public String getMaterialCompanyPO() {
        return materialCompanyPO;
    }
    @ExcelField(title = "PO项目行", align = 2, sort = 26)
    public String getPoLineItem() {
        return poLineItem;
    }
    @ExcelField(title = "合同计划交货日期", align = 2, sort = 27)
    public Date getContractPlannedDeliveryDate() {
        return contractPlannedDeliveryDate;
    }
    @ExcelField(title = "配送单计划交货期", align = 2, sort = 28)
    public String getDeliveryScheduleOfTheDeliveryOrderIsPlanned() {
        return deliveryScheduleOfTheDeliveryOrderIsPlanned;
    }
    @ExcelField(title = "已交货数量", align = 2, sort = 29)
    public String getQuantityDelivered() {
        return quantityDelivered;
    }
    @ExcelField(title = "103物料凭证", align = 2, sort = 30)
    public String getMaterialDocument103() {
        return materialDocument103;
    }
    @ExcelField(title = "103过账日期", align = 2, sort = 31)
    public Date getPostingDate103() {
        return postingDate103;
    }
    @ExcelField(title = "电子验收报告", align = 2, sort = 32)
    public String getElectronicAcceptanceReport() {
        return electronicAcceptanceReport;
    }
    @ExcelField(title = "电子验收报告审批状态", align = 2, sort = 33)
    public String getElectronicAcceptanceReportStatus() {
        return electronicAcceptanceReportStatus;
    }
    @ExcelField(title = "电子验收报告审批日期", align = 2, sort = 34)
    public Date getElectronicAcceptanceReportDate() {
        return electronicAcceptanceReportDate;
    }
    @ExcelField(title = "105物料凭证", align = 2, sort = 35)
    public String getMaterialDocument105() {
        return materialDocument105;
    }
    @ExcelField(title = "105过账日期", align = 2, sort = 36)
    public Date getPostingDate105() {
        return postingDate105;
    }
    @ExcelField(title = "到货登记人", align = 2, sort = 37)
    public String getArrivalRegistrant() {
        return arrivalRegistrant;
    }
    @ExcelField(title = "需求单位", align = 2, sort = 38)
    public String getDemandForTheUnit() {
        return demandForTheUnit;
    }
    @ExcelField(title = "需求单位描述", align = 2, sort = 39)
    public String getRequirementUnitDescription() {
        return requirementUnitDescription;
    }
    @ExcelField(title = "配送地点", align = 2, sort = 40)
    public String getDeliveryPlace() {
        return deliveryPlace;
    }
    @ExcelField(title = "配送地点描述", align = 2, sort = 41)
    public String getDistributionLocationDescription() {
        return distributionLocationDescription;
    }
    @ExcelField(title = "出票方编码", align = 2, sort = 42)
    public String getDrawersCode() {
        return drawersCode;
    }
    @ExcelField(title = "出票方名称", align = 2, sort = 43)
    public String getDrawersName() {
        return drawersName;
    }
    @ExcelField(title = "供应商发票", align = 2, sort = 44)
    public String getSupplierInvoice() {
        return supplierInvoice;
    }
    @ExcelField(title = "开票日期", align = 2, sort = 45)
    public Date getDateOfIssue() {
        return dateOfIssue;
    }
    @ExcelField(title = "交票日期", align = 2, sort = 46)
    public Date getPayTheTicketDate() {
        return payTheTicketDate;
    }



    @ExcelField(title = "发票数量", align = 2, sort = 47)
    public String getInvoiceNumber() {
        return invoiceNumber;
    }
    @ExcelField(title = "发票校验数量", align = 2, sort = 48)
    public String getInvoiceCheckQuantity() {
        return invoiceCheckQuantity;
    }
    @ExcelField(title = "发票金额", align = 2, sort = 49)
    public String getInvoiceAmount() {
        return invoiceAmount;
    }
    @ExcelField(title = "发票状态", align = 2, sort = 50)
    public String getInvoiceStatus() {
        return invoiceStatus;
    }
    @ExcelField(title = "税码", align = 2, sort = 51)
    public String getTaxCode() {
        return taxCode;
    }
    @ExcelField(title = "评估类型", align = 2, sort = 52)
    public String getAssessmentType() {
        return assessmentType;
    }
    @ExcelField(title = "资金属性", align = 2, sort = 53)
    public String getMoneyAttribute() {
        return moneyAttribute;
    }
    @ExcelField(title = "产权属性", align = 2, sort = 54)
    public String getPropertyRightAttribute() {
        return propertyRightAttribute;
    }
    @ExcelField(title = "付款比例", align = 2, sort = 55)
    public String getTheRatioOfPayment() {
        return theRatioOfPayment;
    }
    @ExcelField(title = "预付款", align = 2, sort = 56)
    public String getAdvancePayment() {
        return advancePayment;
    }
    @ExcelField(title = "到货款", align = 2, sort = 57)
    public String getCashOnDelivery() {
        return cashOnDelivery;
    }
    @ExcelField(title = "投运款", align = 2, sort = 58)
    public String getPutMoney() {
        return putMoney;
    }
    @ExcelField(title = "质保款", align = 2, sort = 59)
    public String getQualityAssuranceModel() {
        return qualityAssuranceModel;
    }
    @ExcelField(title = "市级属地", align = 2, sort = 60)
    public String getTheMunicipalTerritory() {
        return theMunicipalTerritory;
    }
    @ExcelField(title = "申请付款金额", align = 2, sort = 61)
    public String getAmountOfApplicationForPayment() {
        return amountOfApplicationForPayment;
    }
    @ExcelField(title = "入库金额", align = 2, sort = 62)
    public String getAmountOfInventory() {
        return amountOfInventory;
    }
    @ExcelField(title = "投运单号", align = 2, sort = 63)
    public String getForTheAwb() {
        return forTheAwb;
    }
    @ExcelField(title = "投运状态", align = 2, sort = 64)
    public String getWaybillStatus() {
        return waybillStatus;
    }
    @ExcelField(title = "质保单号", align = 2, sort = 65)
    public String getQualityPolicyNo() {
        return qualityPolicyNo;
    }
    @ExcelField(title = "质保单状态", align = 2, sort = 66)
    public String getPledgedPolicyStatus() {
        return pledgedPolicyStatus;
    }
    @ExcelField(title = "质保期", align = 2, sort = 67)
    public String getGuaranteePeriod() {
        return guaranteePeriod;
    }
    @ExcelField(title = "计划编制人", align = 2, sort = 68)
    public String getPlanner() {
        return planner;
    }


    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }

    public void setExternalContractNumber(String externalContractNumber) {
        this.externalContractNumber = externalContractNumber;
    }

    public void setFactory(String factory) {
        this.factory = factory;
    }

    public void setFactoryName(String factoryName) {
        this.factoryName = factoryName;
    }

    public void setBatch(String batch) {
        this.batch = batch;
    }

    public void setMaterialCode(String materialCode) {
        this.materialCode = materialCode;
    }

    public void setMaterialDescription(String materialDescription) {
        this.materialDescription = materialDescription;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public void setContractLineItem(String contractLineItem) {
        this.contractLineItem = contractLineItem;
    }

    public void setContractCount(String contractCount) {
        this.contractCount = contractCount;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public void setUnitPrice(String unitPrice) {
        this.unitPrice = unitPrice;
    }

    public void setMoney(String money) {
        this.money = money;
    }

    public void setSupplierCode(String supplierCode) {
        this.supplierCode = supplierCode;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    public void setPurchaseOrder(String purchaseOrder) {
        this.purchaseOrder = purchaseOrder;
    }

    public void setOrderLineItem(String orderLineItem) {
        this.orderLineItem = orderLineItem;
    }

    public void setNetPurchaseOrderPrice(String netPurchaseOrderPrice) {
        this.netPurchaseOrderPrice = netPurchaseOrderPrice;
    }

    public void setPurchaseApplicationNo(String purchaseApplicationNo) {
        this.purchaseApplicationNo = purchaseApplicationNo;
    }

    public void setProjectOfPurchasingApplicantBank(String projectOfPurchasingApplicantBank) {
        this.projectOfPurchasingApplicantBank = projectOfPurchasingApplicantBank;
    }

    public void setPurchaseApplicationQuantity(String purchaseApplicationQuantity) {
        this.purchaseApplicationQuantity = purchaseApplicationQuantity;
    }

    public void setOrderUnit(String orderUnit) {
        this.orderUnit = orderUnit;
    }

    public void setMaterialCompanySO(String materialCompanySO) {
        this.materialCompanySO = materialCompanySO;
    }

    public void setSoLineItem(String soLineItem) {
        this.soLineItem = soLineItem;
    }

    public void setMaterialCompanyPO(String materialCompanyPO) {
        this.materialCompanyPO = materialCompanyPO;
    }

    public void setPoLineItem(String poLineItem) {
        this.poLineItem = poLineItem;
    }

    public void setContractPlannedDeliveryDate(Date contractPlannedDeliveryDate) {
        this.contractPlannedDeliveryDate = contractPlannedDeliveryDate;
    }

    public void setDeliveryScheduleOfTheDeliveryOrderIsPlanned(String deliveryScheduleOfTheDeliveryOrderIsPlanned) {
        this.deliveryScheduleOfTheDeliveryOrderIsPlanned = deliveryScheduleOfTheDeliveryOrderIsPlanned;
    }

    public void setQuantityDelivered(String quantityDelivered) {
        this.quantityDelivered = quantityDelivered;
    }

    public void setMaterialDocument103(String materialDocument103) {
        this.materialDocument103 = materialDocument103;
    }

    public void setPostingDate103(Date postingDate103) {
        this.postingDate103 = postingDate103;
    }

    public void setElectronicAcceptanceReport(String electronicAcceptanceReport) {
        this.electronicAcceptanceReport = electronicAcceptanceReport;
    }

    public void setElectronicAcceptanceReportStatus(String electronicAcceptanceReportStatus) {
        this.electronicAcceptanceReportStatus = electronicAcceptanceReportStatus;
    }

    public void setElectronicAcceptanceReportDate(Date electronicAcceptanceReportDate) {
        this.electronicAcceptanceReportDate = electronicAcceptanceReportDate;
    }

    public void setMaterialDocument105(String materialDocument105) {
        this.materialDocument105 = materialDocument105;
    }

    public void setPostingDate105(Date postingDate105) {
        this.postingDate105 = postingDate105;
    }

    public void setArrivalRegistrant(String arrivalRegistrant) {
        this.arrivalRegistrant = arrivalRegistrant;
    }

    public void setDemandForTheUnit(String demandForTheUnit) {
        this.demandForTheUnit = demandForTheUnit;
    }

    public void setRequirementUnitDescription(String requirementUnitDescription) {
        this.requirementUnitDescription = requirementUnitDescription;
    }

    public void setDeliveryPlace(String deliveryPlace) {
        this.deliveryPlace = deliveryPlace;
    }

    public void setDistributionLocationDescription(String distributionLocationDescription) {
        this.distributionLocationDescription = distributionLocationDescription;
    }

    public void setDrawersCode(String drawersCode) {
        this.drawersCode = drawersCode;
    }

    public void setDrawersName(String drawersName) {
        this.drawersName = drawersName;
    }

    public void setDateOfIssue(Date dateOfIssue) {
        this.dateOfIssue = dateOfIssue;
    }

    public void setPayTheTicketDate(Date payTheTicketDate) {
        this.payTheTicketDate = payTheTicketDate;
    }

    public void setInvoiceNumber(String invoiceNumber) {
        this.invoiceNumber = invoiceNumber;
    }

    public void setInvoiceCheckQuantity(String invoiceCheckQuantity) {
        this.invoiceCheckQuantity = invoiceCheckQuantity;
    }

    public void setInvoiceAmount(String invoiceAmount) {
        this.invoiceAmount = invoiceAmount;
    }

    public void setInvoiceStatus(String invoiceStatus) {
        this.invoiceStatus = invoiceStatus;
    }

    public void setTaxCode(String taxCode) {
        this.taxCode = taxCode;
    }

    public void setAssessmentType(String assessmentType) {
        this.assessmentType = assessmentType;
    }

    public void setMoneyAttribute(String moneyAttribute) {
        this.moneyAttribute = moneyAttribute;
    }

    public void setPropertyRightAttribute(String propertyRightAttribute) {
        this.propertyRightAttribute = propertyRightAttribute;
    }

    public void setTheRatioOfPayment(String theRatioOfPayment) {
        this.theRatioOfPayment = theRatioOfPayment;
    }

    public void setAdvancePayment(String advancePayment) {
        this.advancePayment = advancePayment;
    }

    public void setCashOnDelivery(String cashOnDelivery) {
        this.cashOnDelivery = cashOnDelivery;
    }

    public void setPutMoney(String putMoney) {
        this.putMoney = putMoney;
    }

    public void setQualityAssuranceModel(String qualityAssuranceModel) {
        this.qualityAssuranceModel = qualityAssuranceModel;
    }

    public void setTheMunicipalTerritory(String theMunicipalTerritory) {
        this.theMunicipalTerritory = theMunicipalTerritory;
    }

    public void setAmountOfApplicationForPayment(String amountOfApplicationForPayment) {
        this.amountOfApplicationForPayment = amountOfApplicationForPayment;
    }

    public void setAmountOfInventory(String amountOfInventory) {
        this.amountOfInventory = amountOfInventory;
    }

    public void setForTheAwb(String forTheAwb) {
        this.forTheAwb = forTheAwb;
    }

    public void setWaybillStatus(String waybillStatus) {
        this.waybillStatus = waybillStatus;
    }

    public void setQualityPolicyNo(String qualityPolicyNo) {
        this.qualityPolicyNo = qualityPolicyNo;
    }

    public void setPledgedPolicyStatus(String pledgedPolicyStatus) {
        this.pledgedPolicyStatus = pledgedPolicyStatus;
    }

    public void setGuaranteePeriod(String guaranteePeriod) {
        this.guaranteePeriod = guaranteePeriod;
    }

    public void setPlanner(String planner) {
        this.planner = planner;
    }

    public void setSupplierInvoice(String supplierInvoice) {
        this.supplierInvoice = supplierInvoice;
    }

}
